// image_reader_f.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

//int readImage(const char* filename,AnalyzeImage* img, bool signedData);


int main( int argc, char *argv[])
{

	

	cout << "program started" << endl;

	

	if( argc < 5 )
    {
   // std::cerr << argc <<std::endl;
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " segmented_image_file ascii_image_file ascii_size_file ascii_resolution_file" << std::endl;;
    //std::cerr << " outputImageFile " 
    return EXIT_FAILURE;
    }

	char image_input_file[4000];
	char image_output_file[4000];
	char size_file[4000];
	char resolution_file[4000];



	strcpy(image_input_file, argv[1]);
	strcpy(image_output_file, argv[2]);
	strcpy(size_file, argv[3]);
	strcpy(resolution_file, argv[4]);

	//cout << "names found" << endl;

	AnalyzeImage* img;
	img = new AnalyzeImage[1];

	//cout << "img defined" << endl;

	int val;

	val = readImage(image_input_file, img, false);

	cout << "img read" << endl;

	cout << val << endl;

	ofstream out_stream;

	out_stream.open(image_output_file);

	//for(long k=0;k<img[0].header.z_dim;k++){
	//	for(long j=0;j<img[0].header.y_dim;j++){
	//		for(long i=0;i<img[0].header.x_dim;i++){
		
			

	//			val = getSafeVoxelValue(img, i, j, k);
	//			out_stream << val << " ";

	//		}
	//	}
	//}
	long sum = 0;

	for(long k=-2;k<(img[0].header.z_dim+2);k++){
		for(long j=-2;j<(img[0].header.y_dim+2);j++){
			for(long i=-2;i<(img[0].header.x_dim+2);i++){
		
				if( (k>=0) && (k<img[0].header.z_dim) && (k>=0) && (k<img[0].header.z_dim) &&(k>=0) && (k<img[0].header.z_dim) ){

				val = getSafeVoxelValue(img, i, j, k);
				out_stream << val << " ";
				sum = sum + val;

				}else{

					out_stream << 0 << " ";

				}

			}
		}
	}

	cout << "val is " << sum << endl;

	out_stream.close();

	out_stream.open(size_file);

	//out_stream << img[0].header.x_dim << " " << img[0].header.y_dim << " " << img[0].header.z_dim << endl;

	out_stream << (img[0].header.x_dim+4) << " " << (img[0].header.y_dim+4) << " " << (img[0].header.z_dim+4) << endl;

	out_stream.close();

	out_stream.open(resolution_file);
	out_stream << img[0].header.x_size << " " << img[0].header.y_size << " " << img[0].header.z_size << endl;

	out_stream.close();





	//cout << img[0].header.x_dim << " " << img[0].header.y_dim << " " << img[0].header.z_dim << endl;
	//cout << img[0].header.x_size << " " << img[0].header.y_size << " " << img[0].header.z_size << endl;

	
	

	/*
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//this code replaces the the image with a small circle and writes a .img and .hdr file

	AnalyzeImage* img;
	img = new AnalyzeImage[1];

	int val;

	val = readImage("small_sphere.img", img, false);

	
	cout << val << endl;


	img[0].header.x_dim = 40;
	img[0].header.y_dim = 40;
	img[0].header.z_dim = 40;
	
	AnalyzeHeader header;
	header = img[0].header;
	AnalyzeOutStream out(header);

	

	//long center = 50+50*img[0].header.x_dim + 50*img[0].header.x_dim*img[0].header.y_dim;
	long dist_to_center;

	for(long i=1;i<img[0].header.x_dim;i++){
		for(long j=1;j<img[0].header.y_dim;j++){
			for(long k=0;k<img[0].header.z_dim;k++){

				dist_to_center = (i-20)*(i-20) + (j-20)*(j-20) + (k-20)*(k-20) ;

				if(  dist_to_center < 25 ){

					putVoxelValue(img,i,j,k, 1);

				}else{

					putVoxelValue(img,i,j,k, 0);


				}


			}
		}
	}

	

	out.write(img,false,"vs_sphere.img", true);

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	*/


	return 0;
}

