#include "stdafx.h"
#include "sparse_matrix.h"

 


void sparse_matrix::initialize(long sm_entry_num_input, long length_input){

	sm_entry_num = sm_entry_num_input;

	unsorted_e = new entry[sm_entry_num];

	length = length_input;

	NZREN = new long[length];
	for(long n=0;n<length;n++){
		NZREN[n] = 0;
	}

	sm_entry_count = 0;



}

void sparse_matrix::initialize_s(long sm_entry_num_input, long length_input){

	sm_entry_num = sm_entry_num_input;

	//unsorted_e = new entry[sm_entry_num];

	length = length_input;

	
	diags = new float[length];
	for(long n=0;n<length;n++){
		diags[n] = 0;
	}

	sm_entry_count = 0;

	unsorted_entry_num = sm_entry_num_input;


	uss = new unsort_to_sort[sm_entry_num];
	cout << "made uss " << endl;
	//uss2 = new unsort_to_sort[sm_entry_num];
	

}



void sparse_matrix::add_entry(long row_in, long column_in, float val_in){

	unsorted_e[sm_entry_count].row=row_in;
	unsorted_e[sm_entry_count].column=column_in;
	unsorted_e[sm_entry_count].val=val_in;
	unsorted_e[sm_entry_count].order_number = column_in+row_in*length;

	sm_entry_count = sm_entry_count+1;


}

void sparse_matrix::add_entry_s(long row_in, long column_in, float val_in){

	long sorted_num;

	//long this_e_num = column_in+row_in*length;

	//if(this_e_num != uss2[sm_entry_count].order_number){
	//	cout << this_e_num << " " << uss2[sm_entry_count].order_number << endl;
	//}

	if(row_in == column_in){

		diags[row_in] = diags[row_in]+val_in;

	}else{

	//sorted_num = uss2[sm_entry_count].sort;
	sorted_num = se[sm_entry_count].sort;

	if(row_in > column_in){

		ue[sorted_num].val=ue[sorted_num].val + val_in;
		//e[sorted_num].order_number=uss2[sm_entry_count].order_number;
		ue[sorted_num].order_number= column_in+row_in*length;
		ue[sorted_num].row = row_in;
		ue[sorted_num].column = column_in;

	}else{

		ue[sorted_num].val=ue[sorted_num].val + val_in;
		//e[sorted_num].order_number=uss2[sm_entry_count].order_number;
		ue[sorted_num].order_number= row_in+column_in*length;
		ue[sorted_num].row = column_in;
		ue[sorted_num].column = row_in;




	}

	sm_entry_count = sm_entry_count + 1;

	}

	


}

void sparse_matrix::add_entry_num_to_order_number(long row_in, long column_in){


	if(row_in == column_in){

		

	}else{


	if(row_in > column_in){

		uss[sm_entry_count].order_number = column_in+row_in*length;

	}else{

		uss[sm_entry_count].order_number = row_in+column_in*length;

	}
	uss[sm_entry_count].unsort = sm_entry_count;
	//uss[sm_entry_count].s = sm_entry_count;


	sm_entry_count = sm_entry_count + 1;

	//unsorted_entry_num = unsorted_entry_num + 1;

	}


}


void sparse_matrix::zero(){

	long half_e_count_m_length = half_e_count - length;

	for(long n=0;n<half_e_count_m_length;n++){

		ue[n].val = 0.0;

	}

	for(long n=0;n<length;n++){
		diags[n] = 0;
	}

	sm_entry_count = 0;

}


//bool sparse_matrix::cmp( entry a, entry b ) {
//			return a.order_number < b.order_number;
//		}

bool cmp( entry a, entry b ) {
			return a.order_number < b.order_number;
		}



void sparse_matrix::sort_sparse_matrix(){

	long new_e_count;
	

	
	sort( unsorted_e , unsorted_e + sm_entry_num, cmp );

	

	new_e_count = 1;

	for(long n=1;n<sm_entry_num;n++){

		if(unsorted_e[n].order_number != unsorted_e[n-1].order_number){

			new_e_count = new_e_count + 1;

		}

	}

	e = new entry[new_e_count];
	

	new_e_count = 0;

	
	e[0].column = unsorted_e[0].column;
	e[0].order_number = unsorted_e[0].order_number;
	e[0].row = unsorted_e[0].row;
	e[0].val = unsorted_e[0].val;



	for(long n=1;n<sm_entry_num;n++){

		if(unsorted_e[n].order_number != unsorted_e[n-1].order_number){

			e[new_e_count].column = unsorted_e[n].column;
			e[new_e_count].order_number = unsorted_e[n].order_number;
			e[new_e_count].row = unsorted_e[n].row;
			e[new_e_count].val = unsorted_e[n].val;

			//cout << new_e_count << endl;

			new_e_count = new_e_count + 1;

		}else{

			e[new_e_count].val = e[new_e_count].val + unsorted_e[n].val;	

			//cout << new_e_count << endl;

		}

	}


	new_e_count = new_e_count + 1;

	sm_entry_num = new_e_count;

	//cout << new_e_count << endl;

	//cout << e[0].row << endl;
	//cout << e[1].row << endl;
	//cout << e[2].row << endl;
	//cout << e[3].row << endl;

	NZREN[0] = 1;

	long row_count = 0;

	for(long n=1; n<sm_entry_num; n++){

		if(e[n].row != e[n-1].row){

			row_count = row_count+1;

			NZREN[row_count] = NZREN[row_count]+1;

		}else{

			NZREN[row_count] = NZREN[row_count]+1;

		}


	}

	delete [] unsorted_e;

	//cout << NZREN[0] << endl;
	//cout << NZREN[1] << endl;

	


}

bool cmp2( unsort_to_sort a, unsort_to_sort b ) {
			return a.order_number < b.order_number;
		}


void sparse_matrix::sort_sparse_matrix_s(){

	long new_e_count;
	
	//for(long n=0;n<10;n++){
	//	cout << uss[n].order_number << endl;
	//}

	for(long n=0;n<sm_entry_num;n++){
		if(uss[n].order_number < 0){
			cout << uss[n].order_number << endl;
		}
	}


	cout << "presort" << endl;
	sort( uss , uss + sm_entry_num, cmp2 );
	cout << "sorted" << endl;

	cout << " " << endl;
	//for(long n=0;n<10;n++){
	//	cout << uss[n].order_number << endl;
	//}

	new_e_count = 1;

	for(long n=1;n<sm_entry_num;n++){

		if(uss[n].order_number != uss[n-1].order_number){

			new_e_count = new_e_count + 1;

		}

	}

	


	new_e_count = 0;


	//the order number is overwritten with the sort number

	long previous_order_number;
	long current_order_number;

	
	previous_order_number = uss[0].order_number;
	uss[0].order_number = 0;

	for(long n=1;n<sm_entry_num;n++){

		current_order_number = uss[n].order_number;

		if(current_order_number != previous_order_number){

			uss[n].order_number = uss[n-1].order_number + 1;
			new_e_count = new_e_count + 1;
			previous_order_number = current_order_number;

		}else{

			uss[n].order_number = uss[n-1].order_number;	

			//cout << new_e_count << endl;

		}

	}

	/*
	uss[0].sort = 0;

	for(long n=1;n<sm_entry_num;n++){

		if(uss[n].order_number != uss[n-1].order_number){

			uss[n].sort = uss[n-1].sort + 1;
			new_e_count = new_e_count + 1;

		}else{

			uss[n].sort = uss[n-1].sort;	

			//cout << new_e_count << endl;

		}

	}

	*/


	new_e_count = new_e_count + 1;

	half_e_count = new_e_count + length;
	sm_entry_num = (half_e_count - length)*2 + length;
	long half_e_count_m_length = half_e_count - length;

	sm_entry_count = 0;

	long s, us, on;

	//se = new sort_to_e[unsorted_entry_num];
	//cout << "made uss2 " << endl;



	/*
	for(long n=0;n<unsorted_entry_num;n++){
		
		s = uss[n].sort;
		us = uss[n].unsort;
		on = uss[n].order_number;

		//uss2[us].order_number = on;
		//uss2[us].sort = s;
		//uss2[us].unsort = us;
		//se[us].order_number = on;
		se[us].sort = s;

	}
	*/

	/*
	if(unsorted_entry_num > (16*1) ){
	//to deal with with memory inadequacy, uss is written to a file, then read back in

	ofstream out_stream;

	out_stream.open("temp.txt");

	for(long n=0;n<unsorted_entry_num;n++){

		us = uss[n].unsort;
		on = uss[n].order_number;

		out_stream << us << " " << on << " ";
	
	}

	out_stream.close();

	delete [] uss;

	se = new sort_to_e[unsorted_entry_num];
	cout << "made uss2 " << endl;

	ifstream in_stream;

	in_stream.open("temp.txt");
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	for(long n=0;n<unsorted_entry_num;n++){

		in_stream >> us;
		in_stream >> on;

		se[us].sort = on;
	
	}	

	in_stream.close();


	}else{
	*/

		se = new sort_to_e[unsorted_entry_num];
		cout << "made uss2 " << endl;
	

		for(long n=0;n<unsorted_entry_num;n++){
		
			us = uss[n].unsort;
			on = uss[n].order_number;

			se[us].sort = on;

		}

		delete [] uss;

	//}
	
 

	ue = new entry[half_e_count_m_length];
	for(long n=0;n<half_e_count_m_length;n++){
		ue[n].val = 0;
	}

	e = new entry[sm_entry_num];
	for(long n=0;n<sm_entry_num;n++){
		e[n].val = 0;
	}

	


	//for(long n=(unsorted_entry_num - 1000);n<unsorted_entry_num;n++){
	//	cout << n << " " << uss[n].sort << " " << uss[n].unsort << " " << uss[n].order_number << endl;
	//}

	//for(long n=(unsorted_entry_num - 1000);n<unsorted_entry_num;n++){
	//	cout << n << " " << uss2[n].sort << " " << uss2[n].unsort << " " << uss2[n].order_number << endl;
	//}

	
		
	//exit(1);

	//cout << new_e_count << endl;

	//cout << e[0].row << endl;
	//cout << e[1].row << endl;
	//cout << e[2].row << endl;
	//cout << e[3].row << endl;

	
	//cout << NZREN[0] << endl;
	//cout << NZREN[1] << endl;

	


}


void sparse_matrix::get_NZREN(){

	long counter;
	long half_e_count_m_length = half_e_count - length;

	uss_o = new unsort_to_sort[sm_entry_num];
	cout << "made small uss" << endl;

	counter = 0;

	for(long n=0;n<length;n++){

		uss_o[counter].order_number = n+n*length;
		uss_o[counter].unsort = counter;

		counter = counter + 1;

	}

	for(long n=0;n<half_e_count_m_length;n++){

			uss_o[counter].order_number = ue[n].order_number;
			uss_o[counter].unsort = counter;


			counter = counter + 1;

	}

	for(long n=0;n<half_e_count_m_length;n++){


			//switched row column
			uss_o[counter].order_number = ue[n].row + ue[n].column*length;
			uss_o[counter].unsort = counter;

			counter = counter + 1;


	}



	cout << "small presort" << endl;
	sort( uss_o , uss_o + sm_entry_num, cmp2 );
	cout << "small sorted" << endl;




	long previous_order_number;
	long current_order_number;

	
	previous_order_number = uss_o[0].order_number;
	uss_o[0].order_number = 0;

	for(long n=1;n<sm_entry_num;n++){

		current_order_number = uss_o[n].order_number;

		if(current_order_number != previous_order_number){

			uss_o[n].order_number = uss_o[n-1].order_number + 1;
			previous_order_number = current_order_number;

		}else{

			uss_o[n].order_number = uss_o[n-1].order_number;	

			//cout << new_e_count << endl;

		}

	}


	se_o = new sort_to_e[sm_entry_num];

	long us;
	long on;

		for(long n=0;n<(sm_entry_num);n++){
		
			us = uss_o[n].unsort;
			on = uss_o[n].order_number;

			se_o[us].sort = on;

		}

		delete [] uss_o;

///////////////////////////////////////////////

		



		////////////////////////////////////////////////

	long place;

	counter = 0;

	for(long n=0;n<length;n++){

		place = se_o[counter].sort;

		e[place].column = n;
		e[place].row = n;
		e[place].order_number = e[place].column + e[place].row*length;
		e[place].val = diags[n];

		counter = counter + 1;

	}

	for(long n=0;n<half_e_count_m_length;n++){

			place = se_o[counter].sort;

			e[place].column = ue[n].column;
			e[place].row =  ue[n].row;
			e[place].order_number = e[place].column + e[place].row*length;
			e[place].val = ue[n].val;

			counter = counter + 1;

	}

	for(long n=0;n<half_e_count_m_length;n++){


			place = se_o[counter].sort;

			e[place].column = ue[n].row;
			e[place].row =  ue[n].column;
			e[place].order_number = e[place].column + e[place].row*length;
			e[place].val = ue[n].val;

			counter = counter + 1;



	}



	//for(long n=0;n<1000;n++){
	//	cout << se_o[n].sort << " ";
		//cout << e[n].order_number << " " ;

	//}



//////////////////////////////////////////


	NZREN = new long[length];


	for(long n=0;n<length;n++){
		NZREN[n] = 0;
	}

	NZREN[0] = 1;

	long row_count = 0;

	for(long n=1; n<sm_entry_num; n++){

		if(e[n].row != e[n-1].row){

			row_count = row_count+1;

			NZREN[row_count] = NZREN[row_count]+1;

		}else{

			NZREN[row_count] = NZREN[row_count]+1;

		}


	}

	//for(long n=0;n<length;n++){
	//	cout << NZREN[n] << " " ;
	//}




}

void sparse_matrix::fill_in_other_half(){

	long counter;
	long place;

	counter = 0;

	long half_e_count_m_length = half_e_count - length;

	for(long n=0;n<length;n++){

		place = se_o[counter].sort;

		e[place].column = n;
		e[place].row = n;
		e[place].order_number = e[place].column + e[place].row*length;
		e[place].val = diags[n];

		counter = counter + 1;

	}

	for(long n=0;n<half_e_count_m_length;n++){

			place = se_o[counter].sort;

			e[place].column = ue[n].column;
			e[place].row =  ue[n].row;
			e[place].order_number = e[place].column + e[place].row*length;
			e[place].val = ue[n].val;

			counter = counter + 1;

	}

	for(long n=0;n<half_e_count_m_length;n++){


			place = se_o[counter].sort;

			e[place].column = ue[n].row;
			e[place].row =  ue[n].column;
			e[place].order_number = e[place].column + e[place].row*length;
			e[place].val = ue[n].val;

			counter = counter + 1;



	}
}



