#include "stdafx.h"



#include "node.h"
#include "edge.h"
#include "tet.h"
#include "parameters.h"
#include "face.h"


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//share_face checks if the current face is shared with another tet with a lower number in the tet class array

/*

bool share_face (long p1, long p2, long p3,long tet_number, tet tet_class_array[], long tet_class_array_size){

	bool share_result = false;

	for(long n=0; n<tet_number; n++){

		if(tet_class_array[n].totally_removed == false){

		if(*tet_class_array[n].node1 == p1){
			if(*tet_class_array[n].node2 == p2){
				if(*tet_class_array[n].node3 == p3){
					share_result = true;
				};
				if(*tet_class_array[n].node4 == p3){
					share_result = true;
				};
			};
			if(*tet_class_array[n].node3 == p2){
				if(*tet_class_array[n].node2 == p3){
					share_result = true;
				};
				if(*tet_class_array[n].node4 == p3){
					share_result = true;
				};
			};
			if(*tet_class_array[n].node4 == p2){
				if(*tet_class_array[n].node2 == p3){
					share_result = true;
				};
				if(*tet_class_array[n].node3 == p3){
					share_result = true;
				};
			};
		};
			
		if(*tet_class_array[n].node2 == p1){
			if(*tet_class_array[n].node1 == p2){
				if(*tet_class_array[n].node3 == p3){
					share_result = true;
				};
				if(*tet_class_array[n].node4 == p3){
					share_result = true;
				};
			};
			if(*tet_class_array[n].node3 == p2){
				if(*tet_class_array[n].node1 == p3){
					share_result = true;
				};
				if(*tet_class_array[n].node4 == p3){
					share_result = true;
				};
			};
			if(*tet_class_array[n].node4 == p2){
				if(*tet_class_array[n].node1 == p3){
					share_result = true;
				};
				if(*tet_class_array[n].node3 == p3){
					share_result = true;
				};
			};
		};

		if(*tet_class_array[n].node3 == p1){
			if(*tet_class_array[n].node1 == p2){
				if(*tet_class_array[n].node2 == p3){
					share_result = true;
				};
				if(*tet_class_array[n].node4 == p3){
					share_result = true;
				};
			};
			if(*tet_class_array[n].node2 == p2){
				if(*tet_class_array[n].node1 == p3){
					share_result = true;
				};
				if(*tet_class_array[n].node4 == p3){
					share_result = true;
				};
			};
			if(*tet_class_array[n].node4 == p2){
				if(*tet_class_array[n].node1 == p3){
					share_result = true;
				};
				if(*tet_class_array[n].node2 == p3){
					share_result = true;
				};
			};
		};

		if(*tet_class_array[n].node4 == p1){
			if(*tet_class_array[n].node1 == p2){
				if(*tet_class_array[n].node2 == p3){
					share_result = true;
				};
				if(*tet_class_array[n].node3 == p3){
					share_result = true;
				};
			};
			if(*tet_class_array[n].node2 == p2){
				if(*tet_class_array[n].node1 == p3){
					share_result = true;
				};
				if(*tet_class_array[n].node3 == p3){
					share_result = true;
				};
			};
			if(*tet_class_array[n].node3 == p2){
				if(*tet_class_array[n].node1 == p3){
					share_result = true;
				};
				if(*tet_class_array[n].node2 == p3){
					share_result = true;
				};
			};
		};

		};

	};


	return share_result;

}

*/

bool share_face (long p1, long p2, long p3, long face_number, node node_class_array[], face face_class_array[], long &old){

	bool share_result = false;

	long faces_number = node_class_array[p1].face_belong_entered;

	long *f;
	f = new long[faces_number];
	
	long p[3];

	for(long n=0;n<faces_number;n++){
		f[n] = *node_class_array[p1].face_belong[n];
		p[0] = *face_class_array[f[n]].node1;
		p[1] = *face_class_array[f[n]].node2;
		p[2] = *face_class_array[f[n]].node3;

		if(f[n] != face_number){
			if(p1==p[0]){
				if(p2 == p[1]){
					if(p3 == p[2]){
						share_result = true;
						old = f[n];
					};
				};
				if(p2 == p[2]){
					if(p3 == p[1]){
						share_result = true;
						old = f[n];
					};
				};
			};
			if(p1==p[1]){
				if(p2 == p[0]){
					if(p3 == p[2]){
						share_result = true;
						old = f[n];
					};
				};
				if(p2 == p[2]){
					if(p3 == p[0]){
						share_result = true;
						old = f[n];
					};
				};
			};
			if(p1==p[2]){
				if(p2 == p[0]){
					if(p3 == p[1]){
						share_result = true;
						old = f[n];
					};
				};
				if(p2 == p[1]){
					if(p3 == p[0]){
						share_result = true;
						old = f[n];
					};
				};
			};
		};
	};

	delete [] f;

	return share_result;


}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void remove_node_belongings(node node_class_array[], long node_class_array_size){

	for(long n=0; n<node_class_array_size; n++){

		node_class_array[n].set_edge_belong_number0 ();
		node_class_array[n].set_face_belong_number0 ();

	};

}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//void set_node_belongings_size(node node_class_array[], long node_class_array_size){

//	for(long n=0; n<node_class_array_size; n++){

//		node_class_array[n].set_edge_belong_size ();
//		node_class_array[n].set_face_belong_size ();

//	};

//};









///////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*
long count_face(node node_class_array[], face face_class_array[], tet tet_class_array[], long tet_class_array_size){

	bool share_result;
	long p1;
	long p2;
	long p3;
	long face_number = 0;

	for(long n=0; n<tet_class_array_size; n++){

		if(tet_class_array[n].totally_removed == false){
		
			p1 = *tet_class_array[n].node1;
			p2 = *tet_class_array[n].node2;
			p3 = *tet_class_array[n].node3;

			share_result = share_face (p1, p2, p3, face_number, node_class_array, face_class_array);

			if(share_result == false){
				face_number = face_number + 1;
				ptr = face_class_array[face_number].face_number;
				node_class_array[p1].add_face_belong(ptr);
				node_class_array[p2].face_belong_number_p1 ();
				node_class_array[p3].face_belong_number_p1 ();
			};

			p1 = *tet_class_array[n].node1;
			p2 = *tet_class_array[n].node2;
			p3 = *tet_class_array[n].node4;

			share_result = share_face (p1, p2, p3, face_number, node_class_array, face_class_array);

			if(share_result == false){
				face_number = face_number + 1;
				node_class_array[p1].face_belong_number_p1 ();
				node_class_array[p2].face_belong_number_p1 ();
				node_class_array[p3].face_belong_number_p1 ();
			};

			p1 = *tet_class_array[n].node1;
			p2 = *tet_class_array[n].node3;
			p3 = *tet_class_array[n].node4;

			share_result = share_face (p1, p2, p3, face_number, node_class_array, face_class_array);

			if(share_result == false){
				face_number = face_number + 1;
				node_class_array[p1].face_belong_number_p1 ();
				node_class_array[p2].face_belong_number_p1 ();
				node_class_array[p3].face_belong_number_p1 ();
			};

			p1 = *tet_class_array[n].node2;
			p2 = *tet_class_array[n].node3;
			p3 = *tet_class_array[n].node4;

			share_result = share_face (p1, p2, p3, face_number, node_class_array, face_class_array);

			if(share_result == false){
				face_number = face_number + 1;
				node_class_array[p1].face_belong_number_p1 ();
				node_class_array[p2].face_belong_number_p1 ();
				node_class_array[p3].face_belong_number_p1 ();
			};

		};

	};

	return face_number;

}

*/

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//if a face is shared, a new face should not be created but the existing face needs to be found.

/*

long already_counted_face_number(long p1, long p2, long p3, long current_face, face face_class_array[]){

	long already_counted = -1;

	for(long n=0; n<current_face; n++){

		if(p1 == *face_class_array[n].node1){
			if(p2 == *face_class_array[n].node2){
				if(p3 == *face_class_array[n].node3){
					already_counted = n;
				};
			};
			if(p2 == *face_class_array[n].node3){
				if(p3 == *face_class_array[n].node2){
					already_counted = n;
				};
			};
		};

		if(p1 == *face_class_array[n].node2){
			if(p2 == *face_class_array[n].node1){
				if(p3 == *face_class_array[n].node3){
					already_counted = n;
				};
			};
			if(p2 == *face_class_array[n].node3){
				if(p3 == *face_class_array[n].node1){
					already_counted = n;
				};
			};
		};

		if(p1 == *face_class_array[n].node3){
			if(p2 == *face_class_array[n].node1){
				if(p3 == *face_class_array[n].node2){
					already_counted = n;
				};
			};
			if(p2 == *face_class_array[n].node2){
				if(p3 == *face_class_array[n].node1){
					already_counted = n;
				};
			};
		};

	};

	if(already_counted == -1){
		cout << "broken" << endl;
	};

	return already_counted;
}

*/

long already_counted_face_number(long p1, long p2, long p3, long face_number, node node_class_array[], face face_class_array[]){

	long already_counted = -1;

	long faces_number = node_class_array[p1].face_belong_entered;

	long *f;
	f = new long[faces_number];
	
	long p[3];

	for(long n=0;n<faces_number;n++){
		f[n] = *node_class_array[p1].face_belong[n];
		p[0] = *face_class_array[f[n]].node1;
		p[1] = *face_class_array[f[n]].node2;
		p[2] = *face_class_array[f[n]].node3;

		if(f[n] != face_number){
			if(p1==p[0]){
				if(p2 == p[1]){
					if(p3 == p[2]){
						already_counted = f[n];
					};
				};
				if(p2 == p[2]){
					if(p3 == p[1]){
						already_counted = f[n];
					};
				};
			};
			if(p1==p[1]){
				if(p2 == p[0]){
					if(p3 == p[2]){
						already_counted = f[n];
					};
				};
				if(p2 == p[2]){
					if(p3 == p[0]){
						already_counted = f[n];
					};
				};
			};
			if(p1==p[2]){
				if(p2 == p[0]){
					if(p3 == p[1]){
						already_counted = f[n];
					};
				};
				if(p2 == p[1]){
					if(p3 == p[0]){
						already_counted = f[n];
					};
				};
			};
		};
	};

	if(already_counted == -1){
		cout << "the finding faces ability is broken" << endl;
		exit(1);
	};

	delete [] f;

	return already_counted;


}






//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//the faces from the previous generation are loaded in

void insert_previous_faces(face previous_face_class_array[], long previous_face_class_array_size, face face_class_array[]){

	for(long n=0; n<previous_face_class_array_size; n++){

	face_class_array[n] = previous_face_class_array[n];

	};

};





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


void set_face_class_array(tet tet_class_array[], long tet_class_array_size, face face_class_array[], long &face_class_array_size, node node_class_array[]){

	bool share_result;
	long p1;
	long p2;
	long p3;

	long *ptr;
	long *ptr1;
	long *ptr2;
	long *ptr3;

	long m=0;
	long old = -1;

	//cout << tet_class_array_size << endl;

	for(long n=0 ; n<tet_class_array_size; n++){

		//cout << n << " " << tet_class_array[n].totally_removed  << endl; 

		if(tet_class_array[n].totally_removed == false){
		
			
			//cout << n << " " << *tet_class_array[n].node1 << endl;

			p1 = *tet_class_array[n].node1;
			p2 = *tet_class_array[n].node2;
			p3 = *tet_class_array[n].node3;

			old = -1;
			share_result = share_face (p1, p2, p3, m, node_class_array, face_class_array, old);

			if(share_result == false){
				face_class_array[m].set_remove_false ();
				ptr1 = node_class_array[p1].node_number;
				ptr2 = node_class_array[p2].node_number;
				ptr3 = node_class_array[p3].node_number;
				face_class_array[m].set_face_points (ptr1, ptr2, ptr3);
				ptr = face_class_array[m].face_number;
				tet_class_array[n].set_face1 (ptr);
				node_class_array[p1].add_face_belong(ptr);
				node_class_array[p2].add_face_belong(ptr);
				node_class_array[p3].add_face_belong(ptr);
				m = m + 1;
			}
			else{
				//old = already_counted_face_number(p1, p2, p3, m, node_class_array, face_class_array);
				ptr = face_class_array[old].face_number;
				tet_class_array[n].set_face1 (ptr);
			}

				
			p1 = *tet_class_array[n].node1;
			p2 = *tet_class_array[n].node2;
			p3 = *tet_class_array[n].node4;

			old = -1;
			share_result = share_face (p1, p2, p3, m, node_class_array, face_class_array, old);

			if(share_result == false){
				face_class_array[m].set_remove_false ();
				ptr1 = node_class_array[p1].node_number;
				ptr2 = node_class_array[p2].node_number;
				ptr3 = node_class_array[p3].node_number;
				face_class_array[m].set_face_points (ptr1, ptr2, ptr3);
				ptr = face_class_array[m].face_number;
				tet_class_array[n].set_face2 (ptr);
				node_class_array[p1].add_face_belong(ptr);
				node_class_array[p2].add_face_belong(ptr);
				node_class_array[p3].add_face_belong(ptr);
				m = m + 1;
			}
			else{
				//old = already_counted_face_number(p1, p2, p3, m, node_class_array, face_class_array);
				ptr = face_class_array[old].face_number;
				tet_class_array[n].set_face2 (ptr);
			}

			p1 = *tet_class_array[n].node1;
			p2 = *tet_class_array[n].node3;
			p3 = *tet_class_array[n].node4;

			old = -1;
			share_result = share_face (p1, p2, p3, m, node_class_array, face_class_array, old);

			if(share_result == false){
				face_class_array[m].set_remove_false ();
				ptr1 = node_class_array[p1].node_number;
				ptr2 = node_class_array[p2].node_number;
				ptr3 = node_class_array[p3].node_number;
				face_class_array[m].set_face_points (ptr1, ptr2, ptr3);
				ptr = face_class_array[m].face_number;
				tet_class_array[n].set_face3 (ptr);
				node_class_array[p1].add_face_belong(ptr);
				node_class_array[p2].add_face_belong(ptr);
				node_class_array[p3].add_face_belong(ptr);
				m = m + 1;
			}
			else{
				//old = already_counted_face_number(p1, p2, p3, m, node_class_array, face_class_array);
				ptr = face_class_array[old].face_number;
				tet_class_array[n].set_face3 (ptr);
			}

			p1 = *tet_class_array[n].node2;
			p2 = *tet_class_array[n].node3;
			p3 = *tet_class_array[n].node4;

			old = -1;
			share_result = share_face (p1, p2, p3, m, node_class_array, face_class_array, old);

			if(share_result == false){
				face_class_array[m].set_remove_false ();
				ptr1 = node_class_array[p1].node_number;
				ptr2 = node_class_array[p2].node_number;
				ptr3 = node_class_array[p3].node_number;
				face_class_array[m].set_face_points (ptr1, ptr2, ptr3);
				ptr = face_class_array[m].face_number;
				tet_class_array[n].set_face4 (ptr);
				node_class_array[p1].add_face_belong(ptr);
				node_class_array[p2].add_face_belong(ptr);
				node_class_array[p3].add_face_belong(ptr);
				m = m + 1;
			}
			else{
				//old = already_counted_face_number(p1, p2, p3, m, node_class_array, face_class_array);
				ptr = face_class_array[old].face_number;
				tet_class_array[n].set_face4 (ptr);
			}

		};

	};

	face_class_array_size = m;



}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void resize_face_class_array(face face_class_array[], long face_class_array_size){

	face *temp_class_array;
	temp_class_array = new face[face_class_array_size];

	for(long n=0;n<face_class_array_size;n++){
		temp_class_array[n] = face_class_array[n];
	};

	delete [] face_class_array;
	face_class_array = new face[face_class_array_size];

	for(long n=0;n<face_class_array_size;n++){
		face_class_array[n] = temp_class_array[n];
	};

	delete [] temp_class_array;


}



////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//edges

void resize_edge_class_array(edge edge_class_array[], long edge_class_array_size){


	edge *temp_class_array;
	temp_class_array = new edge[edge_class_array_size];

	for(long n=0;n<edge_class_array_size;n++){
		temp_class_array[n] = edge_class_array[n];
	};

	delete [] edge_class_array;
	edge_class_array = new edge[edge_class_array_size];

	for(long n=0;n<edge_class_array_size;n++){
		edge_class_array[n] = temp_class_array[n];
	};

	delete [] temp_class_array;



}




//share_edge checks if the current edge is shared with another tet with a lower number in the tet class array

/*

bool share_edge (long p1, long p2, long tet_number, tet tet_class_array[], long tet_class_array_size){

	bool share_result = false;

	for(long n=0; n<tet_number; n++){

		if(tet_class_array[n].totally_removed == false){

			if(*tet_class_array[n].node1 == p1){
				if(*tet_class_array[n].node2 == p2){
					share_result = true;
				};
				if(*tet_class_array[n].node3 == p2){
					share_result = true;
				};
				if(*tet_class_array[n].node4 == p2){
					share_result = true;
				};
			};

			if(*tet_class_array[n].node2 == p1){
				if(*tet_class_array[n].node1 == p2){
					share_result = true;
				};
				if(*tet_class_array[n].node3 == p2){
					share_result = true;
				};
				if(*tet_class_array[n].node4 == p2){
					share_result = true;
				};
			};

			if(*tet_class_array[n].node3 == p1){
				if(*tet_class_array[n].node1 == p2){
					share_result = true;
				};
				if(*tet_class_array[n].node2 == p2){
					share_result = true;
				};
				if(*tet_class_array[n].node4 == p2){
					share_result = true;
				};
			};

			if(*tet_class_array[n].node4 == p1){
				if(*tet_class_array[n].node1 == p2){
					share_result = true;
				};
				if(*tet_class_array[n].node2 == p2){
					share_result = true;
				};
				if(*tet_class_array[n].node3 == p2){
					share_result = true;
				};
			};


			
		};

	};


	return share_result;

}

*/

bool share_edge (long p1, long p2, long edge_number, node node_class_array[], edge edge_class_array[], long &old){

	bool share_result = false;

	long edges_number = node_class_array[p1].edge_belong_entered;

	long *e;
	e = new long[edges_number];
	
	long p[2];

	for(long n=0;n<edges_number;n++){
		e[n] = *node_class_array[p1].edge_belong[n];
		p[0] = *edge_class_array[e[n]].node1;
		p[1] = *edge_class_array[e[n]].node2;

		if(e[n] != edge_number){
			if(p1==p[0]){
				if(p2 == p[1]){
						share_result = true;
						old = e[n];
				};
			};
			if(p1==p[1]){
				if(p2==p[0]){
					share_result = true;
					old = e[n];
				};
			};
		};	
		
	};

	delete [] e;

	return share_result;


}



////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*

long count_edge(tet tet_class_array[], long tet_class_array_size){

	bool share_result;
	long p1;
	long p2;
	long edge_number = 0;

	for(long n=0; n<tet_class_array_size; n++){

		if(tet_class_array[n].totally_removed == false){
		
			p1 = *tet_class_array[n].node1;
			p2 = *tet_class_array[n].node2;

			share_result = share_edge(p1, p2, n, tet_class_array, tet_class_array_size);

			if(share_result == false){
				edge_number = edge_number + 1;
			};

			p1 = *tet_class_array[n].node1;
			p2 = *tet_class_array[n].node3;

			share_result = share_edge(p1, p2, n, tet_class_array, tet_class_array_size);

			if(share_result == false){
				edge_number = edge_number + 1;
			};

			p1 = *tet_class_array[n].node1;
			p2 = *tet_class_array[n].node4;

			share_result = share_edge(p1, p2, n, tet_class_array, tet_class_array_size);

			if(share_result == false){
				edge_number = edge_number + 1;
			};

			p1 = *tet_class_array[n].node2;
			p2 = *tet_class_array[n].node3;

			share_result = share_edge(p1, p2, n, tet_class_array, tet_class_array_size);

			if(share_result == false){
				edge_number = edge_number + 1;
			};

			p1 = *tet_class_array[n].node2;
			p2 = *tet_class_array[n].node4;

			share_result = share_edge(p1, p2, n, tet_class_array, tet_class_array_size);

			if(share_result == false){
				edge_number = edge_number + 1;
			};

			p1 = *tet_class_array[n].node3;
			p2 = *tet_class_array[n].node4;

			share_result = share_edge(p1, p2, n, tet_class_array, tet_class_array_size);

			if(share_result == false){
				edge_number = edge_number + 1;
			};			

		};

	};

	return edge_number;

}

*/

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//if an edge is shared, a new edge should not be created but the existing edge needs to be found.

/*

long already_counted_edge_number(long p1, long p2, long current_edge, edge edge_class_array[]){

	long already_counted = -1;

	for(long n=0; n<current_edge; n++){

		if(p1 == *edge_class_array[n].node1){
			if(p2 == *edge_class_array[n].node2){
					already_counted = n;
			};
		};
		if(p1 == *edge_class_array[n].node2){
			if(p2 == *edge_class_array[n].node1){
					already_counted = n;
			};
		};
	};

	if(already_counted == -1){
		cout << "broken" << endl;
	};

	return already_counted;
}

*/

long already_counted_edge_number(long p1, long p2, long edge_number, node node_class_array[], edge edge_class_array[]){

	long already_counted = -1;

	long edges_number = node_class_array[p1].edge_belong_entered;

	long *e;
	e = new long[edges_number];
	
	long p[2];

	for(long n=0;n<edges_number;n++){
		e[n] = *node_class_array[p1].edge_belong[n];
		p[0] = *edge_class_array[e[n]].node1;
		p[1] = *edge_class_array[e[n]].node2;

		if(e[n] != edge_number){
			if(p1==p[0]){
				if(p2 == p[1]){
						already_counted = e[n];
				};
			};
			if(p1==p[1]){
				if(p2==p[0]){
					already_counted = e[n];
				};
			};
		};	
		
	};

	if(already_counted == -1){
		cout << "the finding edges ability is broken" << endl;
		exit(1);
	};

	delete [] e;

	return already_counted;


}



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//the edges from the previous generation are loaded in

void insert_previous_edges(edge previous_edge_class_array[], long previous_edge_class_array_size, edge edge_class_array[]){

	for(long n=0; n<previous_edge_class_array_size; n++){

	edge_class_array[n] = previous_edge_class_array[n];

	};

};





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


void set_edge_class_array(tet tet_class_array[], long tet_class_array_size, edge edge_class_array[], long &edge_class_array_size, node node_class_array[], face face_class_array[]){

	bool share_result;
	long p1;
	long p2;

	long *ptr;
	long *ptr1;
	long *ptr2;

	long m=0;
	long old = -1;

	for(long n=0; n<tet_class_array_size; n++){

		if(tet_class_array[n].totally_removed == false){
		
			p1 = *tet_class_array[n].node1;
			p2 = *tet_class_array[n].node2;

			old=-1;
			share_result = share_edge (p1, p2, m, node_class_array, edge_class_array, old);

			if(share_result == false){
				ptr1 = node_class_array[p1].node_number;
				ptr2 = node_class_array[p2].node_number;
				edge_class_array[m].set_edge_points (ptr1, ptr2);
				ptr = edge_class_array[m].edge_number;
				tet_class_array[n].set_edge (ptr, 0);
				node_class_array[p1].add_edge_belong(ptr);
				node_class_array[p2].add_edge_belong(ptr);
				m = m + 1;
			}
			else{
				//old = already_counted_edge_number(p1, p2, m, node_class_array, edge_class_array);
				ptr = edge_class_array[old].edge_number;
				tet_class_array[n].set_edge (ptr, 0);
			}

				
			p1 = *tet_class_array[n].node1;
			p2 = *tet_class_array[n].node3;

			old = -1;
			share_result =  share_edge (p1, p2, m, node_class_array, edge_class_array, old);

			if(share_result == false){
				ptr1 = node_class_array[p1].node_number;
				ptr2 = node_class_array[p2].node_number;
				edge_class_array[m].set_edge_points (ptr1, ptr2);
				ptr = edge_class_array[m].edge_number;
				tet_class_array[n].set_edge (ptr, 1);
				node_class_array[p1].add_edge_belong(ptr);
				node_class_array[p2].add_edge_belong(ptr);
				m = m + 1;
			}
			else{
				//old = already_counted_edge_number(p1, p2, m, node_class_array, edge_class_array);
				ptr = edge_class_array[old].edge_number;
				tet_class_array[n].set_edge (ptr, 1);
			}


			p1 = *tet_class_array[n].node1;
			p2 = *tet_class_array[n].node4;

			old=-1;
			share_result =  share_edge (p1, p2, m, node_class_array, edge_class_array, old);

			if(share_result == false){
				ptr1 = node_class_array[p1].node_number;
				ptr2 = node_class_array[p2].node_number;
				edge_class_array[m].set_edge_points (ptr1, ptr2);
				ptr = edge_class_array[m].edge_number;
				tet_class_array[n].set_edge (ptr, 2);
				node_class_array[p1].add_edge_belong(ptr);
				node_class_array[p2].add_edge_belong(ptr);
				m = m + 1;
			}
			else{
				//old = already_counted_edge_number(p1, p2, m, node_class_array, edge_class_array);
				ptr = edge_class_array[old].edge_number;
				tet_class_array[n].set_edge (ptr, 2);
			}


			p1 = *tet_class_array[n].node2;
			p2 = *tet_class_array[n].node3;

			old = -1;
			share_result =  share_edge (p1, p2, m, node_class_array, edge_class_array, old);

			if(share_result == false){
				ptr1 = node_class_array[p1].node_number;
				ptr2 = node_class_array[p2].node_number;
				edge_class_array[m].set_edge_points (ptr1, ptr2);
				ptr = edge_class_array[m].edge_number;
				tet_class_array[n].set_edge (ptr, 3);
				node_class_array[p1].add_edge_belong(ptr);
				node_class_array[p2].add_edge_belong(ptr);
				m = m + 1;
			}
			else{
				//old = already_counted_edge_number(p1, p2, m, node_class_array, edge_class_array);
				ptr = edge_class_array[old].edge_number;
				tet_class_array[n].set_edge (ptr, 3);
			}


			p1 = *tet_class_array[n].node2;
			p2 = *tet_class_array[n].node4;

			old = -1;
			share_result =  share_edge (p1, p2, m, node_class_array, edge_class_array, old);

			if(share_result == false){
				ptr1 = node_class_array[p1].node_number;
				ptr2 = node_class_array[p2].node_number;
				edge_class_array[m].set_edge_points (ptr1, ptr2);
				ptr = edge_class_array[m].edge_number;
				tet_class_array[n].set_edge (ptr, 4);
				node_class_array[p1].add_edge_belong(ptr);
				node_class_array[p2].add_edge_belong(ptr);
				m = m + 1;
			}
			else{
				//old = already_counted_edge_number(p1, p2, m, node_class_array, edge_class_array);
				ptr = edge_class_array[old].edge_number;
				tet_class_array[n].set_edge (ptr, 4);
			}


			p1 = *tet_class_array[n].node3;
			p2 = *tet_class_array[n].node4;

			old = -1;
			share_result =  share_edge (p1, p2, m, node_class_array, edge_class_array, old);

			if(share_result == false){
				ptr1 = node_class_array[p1].node_number;
				ptr2 = node_class_array[p2].node_number;
				edge_class_array[m].set_edge_points (ptr1, ptr2);
				ptr = edge_class_array[m].edge_number;
				tet_class_array[n].set_edge (ptr, 5);
				node_class_array[p1].add_edge_belong(ptr);
				node_class_array[p2].add_edge_belong(ptr);
				m = m + 1;
			}
			else{
				//old = already_counted_edge_number(p1, p2, m, node_class_array, edge_class_array);
				ptr = edge_class_array[old].edge_number;
				tet_class_array[n].set_edge (ptr, 5);
			}



		};

	};

	edge_class_array_size = m;
	

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//here, 3 edges are assigned to each face

for(long n=0; n< tet_class_array_size; n++){

	if(tet_class_array[n].totally_removed == false){

	long e[6];
	long f[4];
	long *ptr;

	f[0]=*tet_class_array[n].face1;
	f[1]=*tet_class_array[n].face2;
	f[2]=*tet_class_array[n].face3;
	f[3]=*tet_class_array[n].face4;

	long edges_entered_f[4];
	edges_entered_f[0] = 0;
	edges_entered_f[1] = 0;
	edges_entered_f[2] = 0;
	edges_entered_f[3] = 0;

	for(long m=0; m<6; m++){

		e[m] = *tet_class_array[n].edge_contain[m];


		for(long u=0;u<4; u++){

		if(edge_class_array[e[m]].node1 == face_class_array[f[u]].node1){
			if((edge_class_array[e[m]].node2 == face_class_array[f[u]].node2) ||  (edge_class_array[e[m]].node2 == face_class_array[f[u]].node3)){
				ptr = edge_class_array[e[m]].edge_number;
				face_class_array[f[u]].set_edge_contain ( ptr, edges_entered_f[u]);
				edges_entered_f[u] = edges_entered_f[u] + 1;

			};
		};

		if(edge_class_array[e[m]].node1 == face_class_array[f[u]].node2){
			if((edge_class_array[e[m]].node2 == face_class_array[f[u]].node1) ||  (edge_class_array[e[m]].node2 == face_class_array[f[u]].node3)){
				ptr = edge_class_array[e[m]].edge_number;
				face_class_array[f[u]].set_edge_contain ( ptr, edges_entered_f[u]);
				edges_entered_f[u] = edges_entered_f[u] + 1;

			};
		};

		if(edge_class_array[e[m]].node1 == face_class_array[f[u]].node3){
			if((edge_class_array[e[m]].node2 == face_class_array[f[u]].node1) ||  (edge_class_array[e[m]].node2 == face_class_array[f[u]].node2)){
				ptr = edge_class_array[e[m]].edge_number;
				face_class_array[f[u]].set_edge_contain ( ptr, edges_entered_f[u]);
				edges_entered_f[u] = edges_entered_f[u] + 1;

			};
		};

		};

	}

	};

};

}

