
#include "stdafx.h"
using namespace std;




#ifndef __GridParameters__
#define __GridParameters__


//the parameters to be used in the program are declared in the definition of the class parameters.  The values are set
//in the function initialize_parameters.

class tet_lite
{
	public:
	long *tet_number;
	long *node1, *node2, *node3, *node4;



	short region;

	bool removed;

	void set_remove_false();
	void set_remove_true();


	void new_tet_lite (long *node1_ptr, long *node2_ptr, long *node3_ptr, long *node4_ptr, long t_num, long new_tet_array[]);

};




enum color{no_color, to_red1, have_red1, to_green1a, have_green1a, to_green1b, have_green1b, to_green1c, have_green1c};


class parameters
{
public :


	char filename_ls[4000];
	char filename_region[4000];
	char output_node[4000];
	char output_ele[4000];
	char region_file_z2[4000];
	char ls_file_z2[4000];
	char region_file_z3[4000];
	char ls_file_z3[4000];
	char output_ele_file_z2[4000];
	char output_node_file_z2[4000];
	char output_ele_file_z3[4000];
	char output_node_file_z3[4000];
	char output_node_tbd_z1[4000];
	char output_node_tbd_z2[4000];
	char output_node_tbd_z3[4000];


	long size1D_x_z2;
	long size1D_y_z2;
	long size1D_z_z2;
	long size3D_z2;

	long size1D_xl_z2;
	long size1D_yl_z2;
	long size1D_zl_z2;
	long size3Dl_z2;

	long size1D_x_z3;
	long size1D_y_z3;
	long size1D_z_z3;
	long size3D_z3;

	long size1D_xl_z3;
	long size1D_yl_z3;
	long size1D_zl_z3;
	long size3Dl_z3;



	float x_min;	// front
	float x_max;	// back
	float y_min;	// left
	float y_max;	// right
	float z_min;	// bottom
	float z_max;	// top
	float grid_space;


	long x_nodes;  //number of nodes in the x direction
	long y_nodes;	//number of nodes in the y direction
	long z_nodes;	//number of nodes in the z direction

	long nodes_grid1_number;
	long nodes_grid2_number;
	long initial_node_number;

	long initial_tet_number;


	long size1D_x;
	long size1D_y;
	long size1D_z;
	long size3D;

	long size1D_xl;
	long size1D_yl;
	long size1D_zl;
	long size3Dl;

	float threshold[5];

	short signed_dist_value_refine;
	short signed_dist_integral_refine;

	float int_threshold;

	float smallest_grid_space;

	bool use_lite;

	tet_lite *tet_class_array_red5;
	tet_lite *tet_class_array_green5;

	float *ls_list;

	bool use_list;

	//void initialize_parameters ();
	void initialize_parameters(char*,char*,char*,char*,char*);

};




#endif