#include "stdafx.h"



#include "node.h"
#include "edge.h"
#include "tet.h"
#include "parameters.h"
#include "face.h"
#include "hexa.h"


void tet::initialize_tet (long tet_number_input, long node1_input, long node2_input, long node3_input, long node4_input, long tet_array_initial[], long node_array_grid1[], long node_array_grid2[],parameters &param){

	//note that the first two nodes are from grid2, the second two from grid1

	tet_number = &tet_array_initial[tet_number_input];

	node1 = &node_array_grid2[node1_input];
	node2 = &node_array_grid2[node2_input];
	node3 = &node_array_grid1[node3_input];
	node4 = &node_array_grid1[node4_input];

	removed = false;
	totally_removed = false;

	level = 0;



}




void tet::set_remove_false (){

	removed = false;

}

void tet::set_totally_remove_true (){

	totally_removed = true;
	level = 0;

}

void tet::set_remove_true (){

	removed = true;

}

//void tet::set_no_color (){

//	tet_color = no_color;

//}

//void tet::set_to_red1 (){

//	tet_color = to_red1;

//}

//void tet::set_have_red1 (){

//	tet_color = have_red1;

//}

void tet::set_face1 (long* pointer_to_face1){

	face1 = pointer_to_face1;

}

void tet::set_face2 (long* pointer_to_face2){

	face2 = pointer_to_face2;

}

void tet::set_face3 (long* pointer_to_face3){

	face3 = pointer_to_face3;

}

void tet::set_face4 (long* pointer_to_face4){

	face4 = pointer_to_face4;

}

void tet::set_edge (long *pointer_to_edge, long edge_number){

	edge_contain[edge_number] = pointer_to_edge;

}

void tet::set_edge_number (){

	edge_contain = new long*[6];

}

void tet::new_tet (long *node1_ptr, long *node2_ptr, long *node3_ptr, long *node4_ptr, long t_num, long new_tet_array[], color this_tet_color, short level_input){

	tet_number = &new_tet_array[t_num];

	node1 = node1_ptr;
	node2 = node2_ptr;
	node3 = node3_ptr;
	node4 = node4_ptr;

	removed = false;
	totally_removed = false;

	tet_color = this_tet_color;

	level = level_input;

	edge_contain = new long*[6];

}

void tet::set_tet_color (color this_tet_color){

	tet_color = this_tet_color;

}

void tet::set_greena_edge (long *ptr_to_greena_edge){

	greena_edge = ptr_to_greena_edge;
	

}

void tet::set_greenb_edge (long *ptr_to_greenb_edge1, long *ptr_to_greenb_edge2){

	greenb_edge1 = ptr_to_greenb_edge1;
	greenb_edge2 = ptr_to_greenb_edge2;
	

}

void tet::set_greenc_edge (long *ptr_to_greenc_edge1, long *ptr_to_greenc_edge2, long *ptr_to_greenc_edge3){

	greenc_edge1 = ptr_to_greenc_edge1;
	greenc_edge2 = ptr_to_greenc_edge2;
	greenc_edge3 = ptr_to_greenc_edge3;


}

//void tet::set_greena_edge_split_node (long *ptr_to_greena_edge_split_node){

	//greena_edge_split_node = ptr_to_greena_edge_split_node;

//}

//void tet::set_greenb_edge_split_node (long *ptr_to_greenb_edge1_split_node, long *ptr_to_greenb_edge2_split_node){

//	greenb_edge1_split_node = ptr_to_greenb_edge1_split_node;
//	greenb_edge2_split_node = ptr_to_greenb_edge2_split_node;

//}

//void tet::set_greenc_edge_split_node (long *ptr_to_greenc_edge1_split_node, long *ptr_to_greenc_edge2_split_node, long *ptr_to_greenc_edge3_split_node){

//	greenc_edge1_split_node = ptr_to_greenc_edge1_split_node;
//	greenc_edge2_split_node = ptr_to_greenc_edge2_split_node;
//	greenc_edge3_split_node = ptr_to_greenc_edge3_split_node;

//}


void tet::set_green_up(long* tet_pointer){

	green_tet_up = tet_pointer;

}

void tet::set_greena_tet_down(long* tet_pointer1, long* tet_pointer2){

	green_tet1_down = tet_pointer1;
	green_tet2_down = tet_pointer2;

};

void tet::set_greenb_tet_down(long* tet_pointer1, long* tet_pointer2, long* tet_pointer3, long* tet_pointer4){

	green_tet1_down = tet_pointer1;
	green_tet2_down = tet_pointer2;
	green_tet3_down = tet_pointer3;
	green_tet4_down = tet_pointer4;

};

void tet::set_greenc_tet_down(long* tet_pointer1, long* tet_pointer2, long* tet_pointer3, long* tet_pointer4){

	green_tet1_down = tet_pointer1;
	green_tet2_down = tet_pointer2;
	green_tet3_down = tet_pointer3;
	green_tet4_down = tet_pointer4;

};



void tet::set_red_backup(long red_tet_backup_input[], long new_tet_array[]){

	red_tet_backup = new long*[8];

	for(long n=0; n<8; n++){

		red_tet_backup[n] = &new_tet_array[red_tet_backup_input[n]];

	};


}

void tet::set_region(short region_input){

	region = region_input;

}

////////////////////////////////////////////////////////////////////////////


void tet_lite::new_tet_lite (long *node1_ptr, long *node2_ptr, long *node3_ptr, long *node4_ptr, long t_num, long new_tet_array[]){

	tet_number = &new_tet_array[t_num];

	node1 = node1_ptr;
	node2 = node2_ptr;
	node3 = node3_ptr;
	node4 = node4_ptr;

	removed = false;


}

void tet_lite::set_remove_true (){

	removed = true;

}