#include "stdafx.h"
#include <iostream>
#include <fstream>

//note that all programs work using the floatArray1D.h and floatArray2D.h header files
//////////////////////////////////////////////////////////////////////////////////////

//the 3 by 3 matrices are stored as length 9 array
// [0] (0,0)
// [1] (1,0)
// [2] 2,0
// [3] 0,1
// [4] 1,1
// [5] 2,1
// [6] 0,2
// [7] 1,2
// [8] 2,2

//the 2by2 matrices are storae

//[0] 0,0
//[1] 1,0
//[2] 0,1
//[3] 1,1


void set_zero(long size, float input[]){

	for(long n=0;n<size;n++){
		input[n] = 0;
	}

}



void add(long size, float A[], float B[], float M[]){

	for(long n=0;n<size;n++){
		M[n] = A[n]+B[n];
	}

}

void m_const(long size, float input[], float constant, float M[]){

	for(long n=0;n<size;n++){
		M[n] = constant*input[n];
	}

}



//this program calcualates the determinate of a 2 by 2 matrix

float det2(float N[]){

	float det2;

	det2 = N[0]*N[3] - N[2]*N[1];

	return det2;

}


//this program calcuates the determinate of a 3 by 3 matrix

float det3(float input[], parameters &param){

	float det3;

	//float N1[4];
	//float N2[4];
	//float N3[4];

	param.N1[0] = input[4];
	param.N1[2] = input[7];
	param.N1[1] = input[5];
	param.N1[3] = input[8];

	param.N2[0] = input[1];
	param.N2[2] = input[7];
	param.N2[1] = input[2];
	param.N2[3] = input[8];

	param.N3[0] = input[1];
	param.N3[2] = input[4];
	param.N3[1] = input[2];
	param.N3[3] = input[5];

	//det3 = input[0]*(det2(param.N1)) - input[3]*(det2(param.N2)) + input[6]*(det2(param.N3));
	det3 = input[0]*(param.N1[0]*param.N1[3] - param.N1[2]*param.N1[1]) - input[3]*(param.N2[0]*param.N2[3] - param.N2[2]*param.N2[1]) + input[6]*(param.N3[0]*param.N3[3] - param.N3[2]*param.N3[1]);

	return det3;

}



////////////////////////////////////////////////////////////////////////////////////////
//this program calculates the inverse of a 3 by 3 matrix

void inv3(float input[], float M[], parameters &param){

	//float N1[4];
	//float N2[4];
	//float N3[4];
	//float N4[4];
	//float N5[4];
	//float N6[4];
	//float N7[4];
	//float N8[4];
	//float N9[4];
	//float temp[9];


	param.N1[0]=input[4];
	param.N1[2]=input[7];
	param.N1[1]=input[5];
	param.N1[3]=input[8];

	param.N2[0]=input[6];
	param.N2[2]=input[3];
	param.N2[1]=input[8];
	param.N2[3]=input[5];

	param.N3[0]=input[3];
	param.N3[2]=input[6];
	param.N3[1]=input[4];
	param.N3[3]=input[7];

	param.N4[0]=input[7];
	param.N4[2]=input[1];
	param.N4[1]=input[8];
	param.N4[3]=input[2];

	param.N5[0]=input[0];
	param.N5[2]=input[6];
	param.N5[1]=input[2];
	param.N5[3]=input[8];

	param.N6[0]=input[6];
	param.N6[2]=input[0];
	param.N6[1]=input[7];
	param.N6[3]=input[1];

	param.N7[0]=input[1];
	param.N7[2]=input[4];
	param.N7[1]=input[2];
	param.N7[3]=input[5];

	param.N8[0]=input[3];
	param.N8[2]=input[0];
	param.N8[1]=input[5];
	param.N8[3]=input[2];

	param.N9[0]=input[0];
	param.N9[2]=input[3];
	param.N9[1]=input[1];
	param.N9[3]=input[4];
 
	param.temp[0]= param.N1[0]*param.N1[3] - param.N1[2]*param.N1[1];
	param.temp[3]= param.N2[0]*param.N2[3] - param.N2[2]*param.N2[1];
	param.temp[6]= param.N3[0]*param.N3[3] - param.N3[2]*param.N3[1];
	param.temp[1]= param.N4[0]*param.N4[3] - param.N4[2]*param.N4[1];
	param.temp[4]= param.N5[0]*param.N5[3] - param.N5[2]*param.N5[1];
	param.temp[7]= param.N6[0]*param.N6[3] - param.N6[2]*param.N6[1];
	param.temp[2]= param.N7[0]*param.N7[3] - param.N7[2]*param.N7[1];
	param.temp[5]= param.N8[0]*param.N8[3] - param.N8[2]*param.N8[1];
	param.temp[8]= param.N9[0]*param.N9[3] - param.N9[2]*param.N9[1];

	//param.temp[0]= det2(param.N1);
	//param.temp[3]= det2(param.N2);
	//param.temp[6]= det2(param.N3);
	//param.temp[1]= det2(param.N4);
	//param.temp[4]= det2(param.N5);
	//param.temp[7]= det2(param.N6);
	//param.temp[2]= det2(param.N7);
	//param.temp[5]= det2(param.N8);
	//param.temp[8]= det2(param.N9);

	

	float deter;



	//param.N1[0] = input[4];
	//param.N1[2] = input[7];
	//param.N1[1] = input[5];
	//param.N1[3] = input[8];

	param.N2[0] = input[1];
	param.N2[2] = input[7];
	param.N2[1] = input[2];
	param.N2[3] = input[8];

	//param.N3[0] = input[1];
	//param.N3[2] = input[4];
	//param.N3[1] = input[2];
	//param.N3[3] = input[5];
	//deter = input[0]*det2(param.N1) - input[3]*det2(param.N2) + input[6]*det2(param.N3);
	deter = input[0]*param.temp[0] - input[3]*(param.N2[0]*param.N2[3] - param.N2[2]*param.N2[1]) + input[6]*param.temp[2];


	//cout << deter << " " ;
	
	//m_const(9, param.temp,  (1/det3(input,param)), M);
	//m_const(9, param.temp,  (1/deter), M);

	M[0]= param.temp[0]/deter;
	M[3]= param.temp[3]/deter;
	M[6]= param.temp[6]/deter;
	M[1]= param.temp[1]/deter;
	M[4]= param.temp[4]/deter;
	M[7]= param.temp[7]/deter;
	M[2]= param.temp[2]/deter;
	M[5]= param.temp[5]/deter;
	M[8]= param.temp[8]/deter;

	


}

void inv3_sym(float input[], float M[], parameters &param){

	float N1[4];
	float N2[4];
	float N3[4];
	//float N4[4];
	float N5[4];
	float N6[4];
	//float N7[4];
	//float N8[4];
	float N9[4];
	float temp[9];


	N1[0]=input[4];
	N1[2]=input[7];
	N1[1]=input[5];
	N1[3]=input[8];

	N2[0]=input[6];
	N2[2]=input[3];
	N2[1]=input[8];
	N2[3]=input[5];

	N3[0]=input[3];
	N3[2]=input[6];
	N3[1]=input[4];
	N3[3]=input[7];

	//N4[0]=input[7];
	//N4[2]=input[1];
	//N4[1]=input[8];
	//N4[3]=input[2];

	N5[0]=input[0];
	N5[2]=input[6];
	N5[1]=input[2];
	N5[3]=input[8];

	N6[0]=input[6];
	N6[2]=input[0];
	N6[1]=input[7];
	N6[3]=input[1];

	//N7[0]=input[1];
	//N7[2]=input[4];
	//N7[1]=input[2];
	//N7[3]=input[5];

	//N8[0]=input[3];
	//N8[2]=input[0];
	//N8[1]=input[5];
	//N8[3]=input[2];

	N9[0]=input[0];
	N9[2]=input[3];
	N9[1]=input[1];
	N9[3]=input[4];
 
	temp[0]= det2(N1);
	temp[3]= det2(N2);
	temp[6]= det2(N3);
	temp[1]= temp[3];
	temp[4]= det2(N5);
	temp[7]= det2(N6);
	temp[2]= temp[6];
	temp[5]= temp[7];
	temp[8]= det2(N9);

	m_const(9, temp,  (1/det3(input, param )), M);

}


void transpose3(float input[], float M[]){


	M[0]= input[0];
	M[3]= input[1];
	M[6]= input[2];
	M[1]= input[3];
	M[4]= input[4];
	M[7]= input[5];
	M[2]= input[6];
	M[5]= input[7];
	M[8]= input[8];

}

/////////////
//sets a 3 by 3 matrix to be the identity

void eye3(float M[]){

	M[0]= 1.0;
	M[3]= 0;
	M[6]= 0;
	M[1]= 0;
	M[4]= 1.0;
	M[7]= 0;
	M[2]= 0;
	M[5]= 0;
	M[8]= 1.0;

}

//caclulates trace of a 3 by 3 matrix

float trace3(float input[]){

	float trace3;

	trace3 = input[0]+input[4]+input[8];

	return trace3;

}

//multiplies two 3by3 matrices

void m(float A[], float B[], float M[]){

	M[0]=A[0]*B[0]+A[3]*B[1]+A[6]*B[2];
	M[3]=A[0]*B[3]+A[3]*B[4]+A[6]*B[5];
	M[6]=A[0]*B[6]+A[3]*B[7]+A[6]*B[8];

	M[1]=A[1]*B[0]+A[4]*B[1]+A[7]*B[2];
	M[4]=A[1]*B[3]+A[4]*B[4]+A[7]*B[5];
	M[7]=A[1]*B[6]+A[4]*B[7]+A[7]*B[8];

	M[2]=A[2]*B[0]+A[5]*B[1]+A[8]*B[2];
	M[5]=A[2]*B[3]+A[5]*B[4]+A[8]*B[5];
	M[8]=A[2]*B[6]+A[5]*B[7]+A[8]*B[8];

};

void m_AAT(float A[], float M[]){

	M[0]=A[0]*A[0]+A[3]*A[3]+A[6]*A[6];
	M[3]=A[0]*A[1]+A[3]*A[4]+A[6]*A[7];
	M[6]=A[0]*A[2]+A[3]*A[5]+A[6]*A[8];

	M[1]=M[3];
	M[4]=A[1]*A[1]+A[4]*A[4]+A[7]*A[7];
	M[7]=A[1]*A[2]+A[4]*A[5]+A[7]*A[8];

	M[2]=M[6];
	M[5]=M[7];
	M[8]=A[2]*A[2]+A[5]*A[5]+A[8]*A[8];


}

//determinate of a 4 by 4 matrix
/*
float det4(floatArray2D input){

	float det4;

	floatArray2D M1(3,3);
	floatArray2D M2(3,3);
	floatArray2D M3(3,3);
	floatArray2D M4(3,3);

	M1(0,0)= input(1,1);
	M1(0,1)= input(1,2);
	M1(0,2)= input(1,3);
	M1(1,0)= input(2,1);
	M1(1,1)= input(2,2);
	M1(1,2)= input(2,3);
	M1(2,0)= input(3,1);
	M1(2,1)= input(3,2);
	M1(2,2)= input(3,3);

	M2(0,0)= input(1,0);
	M2(0,1)= input(1,2);
	M2(0,2)= input(1,3);
	M2(1,0)= input(2,0);
	M2(1,1)= input(2,2);
	M2(1,2)= input(2,3);
	M2(2,0)= input(3,0);
	M2(2,1)= input(3,2);
	M2(2,2)= input(3,3);

	M3(0,0)= input(1,0);
	M3(0,1)= input(1,1);
	M3(0,2)= input(1,3);
	M3(1,0)= input(2,0);
	M3(1,1)= input(2,1);
	M3(1,2)= input(2,3);
	M3(2,0)= input(3,0);
	M3(2,1)= input(3,1);
	M3(2,2)= input(3,3);

	M4(0,0)= input(1,0);
	M4(0,1)= input(1,1);
	M4(0,2)= input(1,2);
	M4(1,0)= input(2,0);
	M4(1,1)= input(2,1);
	M4(1,2)= input(2,2);
	M4(2,0)= input(3,0);
	M4(2,1)= input(3,1);
	M4(2,2)= input(3,2);

	det4 = input(0,0)*det3(M1) - input(0,1)*det3(M2) + input(0,2)*det3(M3) - input(0,3)*det3(M4);

	return det4;

}
*/


//outputs a 3by3 matrix and exits the program
void out3(float input[]){

	cout << input[0] << " " << input[3] << " " << input[6] << endl;
	cout << input_(1,0) << " " << input[4] << " " << input[7] << endl;
	cout << input_(2,0) << " " << input[5] << " " << input[8] << endl;
	//exit(1);

}

void cross_product(float a[], float b[], float vec_out[]){

	vec_out[0] = a[1]*b[2]-a[2]*b[1];
	vec_out[1] = a[2]*b[0]-a[0]*b[2];
	vec_out[2] = a[0]*b[1]-a[1]*b[0];


}

float vec_length(float vec[]){

	float length;
	length = sqrt(vec[0]*vec[0]+vec[1]*vec[1]+vec[2]*vec[2]);

	return length;

}


float dot3(float v1[3], float v2[3]){
	float dot_val;

	dot_val = v1[0]*v2[0]+v1[1]*v2[1]+v1[2]*v2[2];

	return dot_val;

}


void psd_inv3(float input[], float M[], parameters &param){

	//(AtA+dI)^(-1)At

	//float det;

	float M1[9];
	float M2[9];
	float M3[9];
	//float M4[9];

	


	transpose3(input, M1);

	//m(input, M1, M2);

	m_AAT(input,M2);

	M2[0]=M2[0] + param.psd;
	M2[4]=M2[4] + param.psd;
	M2[8]=M2[8] + param.psd;

	//inv3(M2, M3);

	inv3_sym(M2, M3, param);

	/*
	det = det3(input);

	if(det >= 0){

		M1[0]=M1[0] + param.psd;
		M1[4]=M1[4] + param.psd;
		M1[8]=M1[8] + param.psd;

	}else{

		M1[0]=M1[0] - param.psd;
		M1[4]=M1[4] - param.psd;
		M1[8]=M1[8] - param.psd;

	}
	*/

	m(M1,M3,M);

}


void psd_inv3_2(float input[], float M[], parameters &param){

	//(AtA+dI)^(-1)At

	//float det;

	float M1[9];
	float M2[9];
	float M3[9];
	//float M4[9];

	


	transpose3(input, M1);

	//m(input, M1, M2);
	
	m_AAT(input,M2);

	M2[0]=M2[0] + param.psd2;
	M2[4]=M2[4] + param.psd2;
	M2[8]=M2[8] + param.psd2;

	//inv3(M2,M3);

	inv3_sym(M2, M3, param);

	/*
	det = det3(input);

	if(det >= 0){

		M1[0]=M1[0] + param.psd;
		M1[4]=M1[4] + param.psd;
		M1[8]=M1[8] + param.psd;

	}else{

		M1[0]=M1[0] - param.psd;
		M1[4]=M1[4] - param.psd;
		M1[8]=M1[8] - param.psd;

	}
	*/

	m(M1,M3,M);

}


void matrix_m_vec(float matrix[], float vec[], float out[]){

	out[0] = matrix[0]*vec[0]+matrix[3]*vec[1]+matrix[6]*vec[2];
	out[1] = matrix[1]*vec[0]+matrix[4]*vec[1]+matrix[7]*vec[2];
	out[2] = matrix[2]*vec[0]+matrix[5]*vec[1]+matrix[8]*vec[2];

}
