#include "stdafx.h"

void cross_product(float a[], float b[], float vec_out[]);
float vec_length(float vec[]);
void add(long size, float A[], float B[], float M[]);

short region(float x, float y, float z,  short regions_array[], parameters &param);



//void parameters::get_names(char *segmentation_file_initial, char* segmentation_file_final, char* level_set_file_initial, char* node_file, char* ele_file, char* final_ele1, char* final_node1, char* file_F1, char* final_face1, char* node_file_undef1, char* node_file_elast01){
void parameters::get_names(char *region_filei, char* ls_filei, char* node_in_filei, char* ele_filei, char* node_out_filei, char* parameters_filei, char* node_undef_filei, char* ele_out_filei, char* face_out_filei){

	cout << "node file is " << node_in_filei << endl;
	cout << "ele file is " << ele_filei << endl;
	cout << " region  file is " << region_filei << endl;
	//cout << "final region file is " << segmentation_file_final << endl;
	cout << "level set function is " << ls_filei << endl;


	strcpy(filename_node, node_in_filei);//"output.node" );
	strcpy(filename_ele, ele_filei);//"output.ele" );
	strcpy(filename_node_jagged_corrected, "initial_corrected.node" );
	strcpy(filename_ele_jagged_corrected, "initial_corrected.ele" );


	strcpy(filename_initial_region, region_filei);//"sphere_4r_region.txt" );
	strcpy(filename_final_region, region_filei);// "sphere_4r_shift_region.txt" );
	strcpy(filename_initial_vec_x, "vec_x.txt" );
	strcpy(filename_initial_vec_y, "vec_y.txt" );
	strcpy(filename_initial_vec_z, "vec_z.txt" );
	strcpy(filename_final_vec_x, "final_vec_x.txt" );
	strcpy(filename_final_vec_y, "final_vec_y.txt" );
	strcpy(filename_final_vec_z, "final_vec_z.txt" );
	strcpy(filename_level_set, ls_filei);//"sphere_4r_ls.txt" );
	strcpy(node_file_undef, node_undef_filei);
	strcpy(node_file_elast0, node_in_filei);


	strcpy(final_ele, ele_out_filei);
	strcpy(final_node, node_out_filei);
	strcpy(file_F, "file_F.m");
	strcpy(final_face, face_out_filei);

	strcpy(parameters_file1, parameters_filei);

}



//void parameters::initialize_parameters(long nodes_number_input, long tets_number_input, int sx, int sy, int sz, int jag, int ts_num, int eps1, int E1, int alpha1, int zeta1, int zoom_level1, int beta1, int min_angle1, int max_angle1, int min_timestep1, int inflation1){
void parameters::initialize_parameters(long nodes_number_input, long tets_number_input){


	long size_xi;
	long size_yi;
	long size_zi;
	float timestep_sizei;
	long timestep_numberi;
	float alphai;
	float betai;
	float Ci;
	float kappai;
	float k1i;
	float k2i;
	float k3i;
	float e1i;
	float e2i;
	float e3i;
	float ls_derivative_smoothingi;
	float res_xi;
	float res_yi;
	float res_zi;
	ifstream in_stream;
	in_stream.open(parameters_file1);

	in_stream >> size_xi ;
	in_stream >> size_yi ;
	in_stream >> size_zi ;
	in_stream >> timestep_sizei;
	in_stream >> timestep_numberi;
	in_stream >> alphai;
	in_stream >> betai;
	in_stream >> Ci;
	in_stream >> kappai;
	in_stream >> k1i;
	in_stream >> k2i;
	in_stream >> k3i;
	in_stream >> e1i;
	in_stream >> e2i;
	in_stream >> e3i;
	in_stream >> ls_derivative_smoothingi;
	in_stream >> res_xi;
	in_stream >> res_yi;
	in_stream >> res_zi;
	in_stream.close();

	res_x = res_xi;
	res_y = res_yi;
	res_z = res_zi;


	kappa = kappai;
	C = Ci;
	k1 = k1i;
	k2 =  k2i;
	k3 = k3i;
	e1 = e1i;
	e2 = e2i;
	e3 = e3i;


	zoom_level = 1;//zoom_level1;
	
	//for time step use ???

	//delta_t = 1.28;
	//time_step_number = ts_num;//time_step_number =400;
	delta_t = timestep_sizei;
	//time_step_number = timestep_sizei;
	time_step_number = 0;


	imq_delta_t = .001;
	imq_time_step_number = 20;

	if(zoom_level == 1){
		stop = .999;
	}else{
		stop = .999;
	}

	//cout << " !!!!!!!!!!!!!!!!!!!!!!!!!!!!!! time step altered to 200 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! "<< endl;
	//time_step_number = 200;


	
	//eps relates to how smooth the delta function is

	//eps = float(eps1);//.1;
	//eps = eps/1000.0;
	eps = .1;

	//cout << "eps = " << eps << endl;

	//pi is pi

	pi=3.14159;

	//use jagged_compression for the initial compression of the jagged tetrahedrah
	//jagged_compression = true;

	//if(jag == 1){
		jagged_compression = true;
	//}
	//if(jag == 0){
	//	jagged_compression = false;
	//}

	// can be used to make the objects look smoother
	if(jagged_compression == true){
	
		//constrain_time_step = time_step_number/2;
		constrain_time_step = 0;

		fix_time_step = time_step_number+1;
	}else{
		constrain_time_step = time_step_number+1;
		fix_time_step = time_step_number+1;
	}

	constrain=false;
	fix = false;

	//you can print on a specified region (in addition to the whole thing)
	region_print=2;

	//E is young's modulus and P is the poisson ratio;
	//E=float(E1);//E=2.0;
	E=2.0;
	p=0.3;


	size1D_x = size_xi;//sx;//40;
	size1D_y = size_yi;//sy;//40;
	size1D_z = size_zi;//sz;//40;

	original_size1D_x = size1D_x;
	original_size1D_y = size1D_y;
	original_size1D_z = size1D_z;
	


	//

	if( (size1D_x % 2) == 1 ){
		size1D_x = size1D_x + 1;
	}
	if( (size1D_x % 4) == 2 ){
		size1D_x = size1D_x + 2;
	}

	if( (size1D_y % 2) == 1 ){
		size1D_y = size1D_y + 1;
	}
	if( (size1D_y % 4) == 2 ){
		size1D_y = size1D_y + 2;
	}

	if( (size1D_z % 2) == 1 ){
		size1D_z = size1D_z + 1;
	}
	if( (size1D_z % 4) == 2 ){
		size1D_z = size1D_z + 2;
	}


	size3D = size1D_x*size1D_y*size1D_z;




	//

	img_size = size3D;


	size1D_x_z2=size1D_x/2+16;
	size1D_y_z2=size1D_y/2+16;
	size1D_z_z2=size1D_z/2+16;
	size3D_z2 = size1D_x_z2*size1D_y_z2*size1D_z_z2;

	size1D_x_z3=size1D_x/4+16;
	size1D_y_z3=size1D_y/4+16;
	size1D_z_z3=size1D_z/4+16;
	size3D_z3 = size1D_x_z3*size1D_y_z3*size1D_z_z3;

	size1D_xl_z2=size1D_x_z2*2;
	size1D_yl_z2=size1D_y_z2*2;
	size1D_zl_z2=size1D_z_z2*2;
	size3Dl_z2 = size3D_z2*8;

	size1D_xl_z3=size1D_x_z3*2;
	size1D_yl_z3=size1D_y_z3*2;
	size1D_zl_z3=size1D_z_z3*2;
	size3Dl_z3 = size3D_z3*8;


	size1D_x=size1D_x+16;
	size1D_y=size1D_y+16;
	size1D_z=size1D_z+16;
	size3D = size1D_x*size1D_y*size1D_z;

	size1D_xl = 2*size1D_x;
	size1D_yl = 2*size1D_y;
	size1D_zl = 2*size1D_z;
	size3Dl = 8*size3D;


	cout << "size1D_x =" << size1D_x << endl;
	cout << "size1D_y =" << size1D_y << endl;
	cout << "size1D_z =" << size1D_z << endl;


	//region 0 (the background ) is always around.  max_number_of_regions should be larger than the largest region number;
	max_number_of_regions = 300;

	all_vector_field_size_initial = size3D;
//	all_vector_field_size_final = size3D*(number_of_regions+1);

	nodes_number = nodes_number_input;
	tets_number = tets_number_input;

	//how far the nodes are to the boundary of the initial image.  should be small
	node_dist_to_true_boundary=0.5;

	//alpha is a measure of how strong the image matching "forces" are.  8.0 seem ok for E=2, grid_space = 2 (and using zeta =2.0).  
	//for grid_space = 1, I used 4.0 (E=2 and zeta=2). If alpha is larger
	//the tetrahedrah will get more squished resulting in a smaller time step, but if it works the matching will be better
	//alpha=float(alpha1);//2.0;

	//alpha = 2000;
	//cout << "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! alpha set to 2000 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" << endl;

	alpha = alphai;//alpha/100;

	cout << "alpha =" << alpha << endl;
	//alpha = 0.1;
	//cout << "alpha = " << alpha << endl;

	beta = betai;//beta1;

	//beta=beta/100.0;
	cout << "beta = " << beta << endl;

	//beta = .1;
	//cout << "beta = " << beta << endl;

	//specify the magnitude of the boundary vectors
	boundary_vector_magnitude = .9;

	

	//smallest_insphere_radius over time_step divided 
	zeta = 4.0;

	//zeta = 15;
	//cout << "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! zeta set to 15 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" << endl;

	//zeta = zeta/100;

	//cout << "zeta =" << zeta << endl;

	//if(jagged_compression == false){
		//delta_t=zeta/100;
		cout << "time step size is fixed at " << delta_t << endl;
	//}

	


	min_angle = 0.0;//float(min_angle1);
	//cout << "min angle =" << min_angle << endl;

	max_angle = 360.0;//float(max_angle1);
	//cout << "max angle =" << max_angle << endl;

	min_timestep = 0;//float(min_timestep1);
	
	//cout << " !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!min time step altered to 6000 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! "<< endl;
	//min_timestep = 6000;

	//min_timestep = min_timestep/1000000;
	//cout << "min timestep =" << min_timestep << endl;

	inflate = new bool[tets_number];
	for(long n=0;n<tets_number;n++){
		inflate[n] = false;
	}

	inflation = ls_derivative_smoothingi;//float(inflation1);


	cout << "inflation =" << ls_derivative_smoothingi << endl;
	//inflation = inflation/100;

		psd = inflation;
		psd2 = psd/10;





	boundary_tet = new bool[tets_number];
	for(long n=0;n<tets_number;n++){
		boundary_tet[n] = false;
	}



	smoothing_thresh = alpha/10.0;



	//dX_array = new float[9*tets_number];

	inverted = new bool[tets_number];
	for(long n=0;n<tets_number;n++){
		inverted[n] = false;
	}

	n_x=new float[nodes_number];
	n_y=new float[nodes_number];
	n_z=new float[nodes_number];
	t_1=new long[tets_number];
	t_2=new long[tets_number];
	t_3=new long[tets_number];
	t_4=new long[tets_number];
	t_r=new short[tets_number];
	

	conv = new long[nodes_number];

	SG = true;
	//SG = false;
	//for now SG only works for morphing

	//if(jagged_compression == true){
	//	SG = false;
	//}

	tet_mem_lim = 12000000;

}

void parameters::get_target_image_size(short regions_array[]){



	long s3D;
	float mult;

	if(zoom_level == 1){
		s3D = size3D;
		mult = 1.0;
	}
	if(zoom_level == 2){
		s3D = size3D_z2;
		mult = 8.0;
		img_size = img_size*8;
	}
	if(zoom_level == 3){
		s3D = size3D_z3;
		mult = 64.0;
		img_size = img_size*64;
	}


	target_image_size = new float[max_number_of_regions];
	empty_space_size = new float[max_number_of_regions];
	M = new float[max_number_of_regions];

	for(short n=0;n<max_number_of_regions;n++){

		target_image_size[n]=0;
		empty_space_size[n]=0;
		M[n]=0;

	}


	for(short m=0;m<max_number_of_regions;m++){

		for(long n=0;n<s3D;n++){
			if(regions_array[n] == m){
				target_image_size[m] = target_image_size[m] + mult;
			}
		}

		empty_space_size[m] = 2*target_image_size[m];

	}


	

	F = new float[time_step_number];
	G = new float[time_step_number];

}

