





class parameters{

	public:

	char filename_node[4000];
	char filename_ele[4000];
	char filename_node_jagged_corrected[4000];
	char filename_ele_jagged_corrected[4000];

	char filename_initial_region[4000];
	char filename_final_region[4000];
	char filename_initial_vec_x[4000];
	char filename_initial_vec_y[4000];
	char filename_initial_vec_z[4000];
	char filename_final_vec_x[4000];
	char filename_final_vec_y[4000];
	char filename_final_vec_z[4000];
	char filename_level_set[4000];

	char final_ele[4000];
	char final_node[4000];
	char final_face[4000];

	char node_file_undef[4000];
	char node_file_elast0[4000];

	char file_F[4000];

	char parameters_file1[4000];

	float kappa;
	float C;
	float k1;
	float k2;
	float k3;
	float e1;
	float e2;
	float e3;


	short zoom_level;

	float p;
	float E;

	float delta_t;
	long time_step_number;
	long constrain_time_step;
	long fix_time_step;

	float imq_delta_t;
	long imq_time_step_number;

	float psd;
	float psd2;

	float eps;

	float img_size;

	long size1D_x_z2;
	long size1D_y_z2;
	long size1D_z_z2;
	long size3D_z2;

	long size1D_xl_z2;
	long size1D_yl_z2;
	long size1D_zl_z2;
	long size3Dl_z2;

	long size1D_x_z3;
	long size1D_y_z3;
	long size1D_z_z3;
	long size3D_z3;

	long size1D_xl_z3;
	long size1D_yl_z3;
	long size1D_zl_z3;
	long size3Dl_z3;



	long size1D_x;
	long size1D_y;
	long size1D_z;
	long size3D;

	long size1D_xl;
	long size1D_yl;
	long size1D_zl;
	long size3Dl;

	short region_print;

	long nodes_number;
	long tets_number;
	long faces_number;

	short max_number_of_regions;

	long all_vector_field_size_initial;
	long all_vector_field_size_final;

	float node_dist_to_true_boundary;

	float alpha;
	float beta;

	float pi;

	bool jagged_compression;
	bool constrain;
	bool fix;

	float boundary_vector_magnitude;

	float *target_image_size;
	float *empty_space_size;
	float *M;

	float smallest_insphere_radius;

	float zeta;
	
	float smoothing_thresh;

	float ls_max;

	float *F;
	float *G;
	long t;

	float stop;

	float initial_smallest_insphere_size;
	float initial_smallest_timestep;

	float min_angle;
	float max_angle;
	float min_timestep;

	float inflation;

	bool *inflate;
	bool *boundary_tet;

	float *dX_array_0;
	float *dX_array_3;
	float *dX_array_6;
	float *dX_array_1;
	float *dX_array_4;
	float *dX_array_7;
	float *dX_array_2;
	float *dX_array_5;
	float *dX_array_8;

	float *inv3_dX_array_0;
	float *inv3_dX_array_3;
	float *inv3_dX_array_6;
	float *inv3_dX_array_1;
	float *inv3_dX_array_4;
	float *inv3_dX_array_7;
	float *inv3_dX_array_2;
	float *inv3_dX_array_5;
	float *inv3_dX_array_8;

	float *inv3_dx_array_0;
	float *inv3_dx_array_3;
	float *inv3_dx_array_6;
	float *inv3_dx_array_1;
	float *inv3_dx_array_4;
	float *inv3_dx_array_7;
	float *inv3_dx_array_2;
	float *inv3_dx_array_5;
	float *inv3_dx_array_8;


	bool *inverted;
	long inverted_count;

	float *n_x;
	float *n_y;
	float *n_z;
	long *t_1;
	long *t_2;
	long *t_3;
	long *t_4;
	short *t_r;
	float *enf_x;
	float *enf_y;
	float *enf_z;
	float *lsnf_x;
	float *lsnf_y;
	float *lsnf_z;
	float *snf_x;
	float *snf_y;
	float *snf_z;

	float *tet_dls_dx;
	float *tet_dls_dy;
	float *tet_dls_dz;

	long SG_length;
	long SG_initial_entry_num;

	float *vec_b_xu;
	float *vec_b_yu;
	float *vec_b_zu;

	float *vec_b_x;
	float *vec_b_y;
	float *vec_b_z;

	long *conv;
	long *conv_inv;

	bool SG;
	bool first_SG;


	bool done_timestepping;

	float *vec_r_k;
	float *vec_r_kp1;
	float *vec_p_k; 
	float *vec_p_kp1; 
	float *vec_x_k; 
	float *vec_x_kp1; 
	float *vec_A_p_k; 
	float *vec_A_x0; 

	float *vec_b;
	float *vec_x;

	long tet_mem_lim;

	//
	float N1[4];
	float N2[4];
	float N3[4];
	float N4[4];
	float N5[4];
	float N6[4];
	float N7[4];
	float N8[4];
	float N9[4];
	float temp[9];
	float M1[9];
	float M2[9];
	float M3[9];
	float temp_det;

	long original_size1D_x;
	long original_size1D_y;
	long original_size1D_z;
	float res_x;
	float res_y;
	float res_z;

	void get_target_image_size(short regions_array[]);

	void initialize_parameters(long nodes_number_input, long tets_number_input);

	//void get_names(char*,char*,char*,char*,char*,char*,char*, char*, char*, char*, char*);
	void get_names(char*,char*,char*,char*,char*,char*, char*, char*, char*);



};