#include "perform_front_propagation_3d.h"
#include "fib.h"
#include "fibpriv.h"
#include <iostream>
#include <fstream>
#include<iomanip>

#include"parameters.h"
using namespace std;


 void pre_process_regions(short regions_array[], parameters param){

	 for(long n=0;n<param.size3D;n++){
		 if(regions_array[n]<0){
			 regions_array[n] = regions_array[n] + 300;
		 }
	 }
 }


//groups 8 voxels into 1.  changes parameters.



void zoom_out(short regions_array[], short new_regions_array[], parameters &param){

	short region_counter[300];
	short vals[8];
	short max_val;
	short max_entered;
	long index;

	if( (param.size1D_x % 2) == 1){
		cout << "still isn't adapted to work if image size doesn't divide by 2 sufficiently many times" << endl;
		exit(1);
	}
	if( (param.size1D_y % 2) == 1){
		cout << "still isn't adapted to work if image size doesn't divide by 2 sufficiently many times" << endl;
		exit(1);
	}
	if( (param.size1D_z % 2) == 1){
		cout << "still isn't adapted to work if image size doesn't divide by 2 sufficiently many times" << endl;
		exit(1);
	}


	long new_size1D_x = param.size1D_x/2;
	long new_size1D_y = param.size1D_y/2;
	long new_size1D_z = param.size1D_z/2;

	for(long kk=0; kk<(new_size1D_z);kk++){
		for(long jj=0;jj<(new_size1D_y);jj++){
			for(long ii=0;ii<(new_size1D_x);ii++){

				for(short m=0;m<300;m++){
					region_counter[m]=0;
				}

				vals[0] = regions_array_(2*ii,2*jj,2*kk);
				vals[1] = regions_array_(2*ii+1,2*jj,2*kk);
				vals[2] = regions_array_(2*ii,2*jj+1,2*kk);
				vals[3] = regions_array_(2*ii,2*jj,2*kk+1);
				vals[4] = regions_array_(2*ii+1,2*jj+1,2*kk);
				vals[5] = regions_array_(2*ii+1,2*jj,2*kk+1);
				vals[6] = regions_array_(2*ii,2*jj+1,2*kk+1);
				vals[7] = regions_array_(2*ii+1,2*jj+1,2*kk+1);

				for(short m=0;m<8;m++){
					region_counter[vals[m]]=region_counter[vals[m]]+1;
				}

				//assigning large voxel value.  doesn't carefully deal with the case of a tie

				max_val = 0;
				max_entered = 0;

				for(short m=1; m<300;m++){
					if(region_counter[m] > max_entered){
						max_val = m;
						max_entered = region_counter[m];
					}
				}

				index = ii+jj*new_size1D_x+kk*new_size1D_x*new_size1D_y;

				new_regions_array[index] = max_val;


			}
		}
	}

	param.size1D_x = new_size1D_x;
	param.size1D_y = new_size1D_y;
	param.size1D_z = new_size1D_z;
	param.size3D = new_size1D_x*new_size1D_y*new_size1D_z;




}







				



