#include "stdafx.h"



#include "node.h"
#include "edge.h"
#include "tet.h"
#include "parameters.h"
#include "face.h"



void compile_node_class_arrays( node node_class_array_input[], long node_class_array_input_size, node node_class_array_red_input[], long node_class_array_red_input_size, node node_class_array_output[]){

	for(long n=0; n<node_class_array_input_size; n++){

		node_class_array_output[n] = node_class_array_input[n];

	}

	for(long n=node_class_array_input_size; n<(node_class_array_input_size + node_class_array_red_input_size); n++){

		node_class_array_output[n] = node_class_array_red_input[n - node_class_array_input_size];

	}

};

void compile_tet_class_arrays( tet tet_class_array_input[], long tet_class_array_input_size, tet tet_class_array_red_input[], long tet_class_array_red_input_size, tet tet_class_array_green_input[], long tet_class_array_green_input_size, tet tet_class_array_output[]){

	for(long n=0; n<tet_class_array_input_size; n++){

		tet_class_array_output[n] = tet_class_array_input[n];

	}

	for(long n=tet_class_array_input_size; n<(tet_class_array_input_size + tet_class_array_red_input_size); n++){

		tet_class_array_output[n] = tet_class_array_red_input[n - tet_class_array_input_size];

	}

	for(long n=(tet_class_array_input_size + tet_class_array_red_input_size); n<(tet_class_array_input_size + tet_class_array_red_input_size + tet_class_array_green_input_size); n++){

		tet_class_array_output[n] = tet_class_array_green_input[n - (tet_class_array_input_size + tet_class_array_red_input_size)];

	}

};

