#include "stdafx.h"



#include "node.h"
#include "edge.h"
#include "tet.h"
#include "parameters.h"
#include "face.h"


		





//pre green
void pre_green(tet tet_class_array[], long tet_class_array_size, edge edge_class_array[], face face_class_array[]){


//loop through tets that haven't been red refined

//count the number of edges that have been split

// if 0 do nothing

//if 1 do green1

//if 2 

//on the same face add a new node

//not on the same face do green2

//if 3 

//on the same face do green3

//not on the same face, mark for red refinement




long tet_split_count;
long e[6];
long e_s[6];
long f[4];

long *ptr_to_greena_edge;
long *ptr_to_greenb_edge1;
long *ptr_to_greenb_edge2;
long *ptr_to_greenc_edge1;
long *ptr_to_greenc_edge2;
long *ptr_to_greenc_edge3;

long up;
long down1;
long down2;
long down3;
long down4;

//long already_split_edge1;
//long already_split_edge2;
//long already_split_edge3;

//long *already_split_edge1_node;
//long *already_split_edge2_node;
//long *already_split_edge3_node;

long t_bp[8];
long e_o[6];

long new_edge_to_split;

bool greenb_mark = false;
bool greenc_mark = false;


	for(long n=0; n<tet_class_array_size; n++){

		if(tet_class_array[n].removed == false ){
			if(tet_class_array[n].tet_color != to_red1){


				greenb_mark = false;
				greenc_mark = false;
				tet_split_count = 0;

				f[0] = *tet_class_array[n].face1;
				f[1] = *tet_class_array[n].face2;
				f[2] = *tet_class_array[n].face3;
				f[3] = *tet_class_array[n].face4;



				for(long m=0; m<6; m++){
					e_s[m] = -1;
					e[m] = *tet_class_array[n].edge_contain[m];
					
					if( (edge_class_array[e[m]].edge_split == to_split1) || ( (edge_class_array[e[m]].edge_split == have_split1) && (edge_class_array[e[m]].use_split == true) )){
						e_s[tet_split_count] = *tet_class_array[n].edge_contain[m];
						tet_split_count = tet_split_count + 1;
					};
				};


				//////////////////////////////////////////////////////////////////////////////////////
				//if a triangle that has already been green refined has a split edge, all the green triangles
				//in the larger triangle (either 2 or 4) need to be removed and the large triangle should be
				//marked for red refinement
				
				if(tet_split_count > 0){
					if(tet_class_array[n].tet_color == have_green1a){

						up = *tet_class_array[n].green_tet_up;

						down1 = *tet_class_array[up].green_tet1_down;
						down2 = *tet_class_array[up].green_tet2_down;

						tet_class_array[down1].set_remove_true ();
						tet_class_array[down2].set_remove_true ();

						//setting the 6 edges of the large triangle to be split

						for(long m=0; m<6; m++){

							e_o[m] = *tet_class_array[up].edge_contain[m];
							edge_class_array[e_o[m]].set_use_split_true ();

						};


						//inserting the 8 red refined triangles

						for(long m=0; m<8; m++){

							t_bp[m] = *tet_class_array[up].red_tet_backup[m];
							tet_class_array[t_bp[m]].set_remove_false ();

						};


						//tet_class_array[up].set_tet_color(to_red1);
						//tet_class_array[up].set_remove_false ();

						//for(long m=0; m<6; m++){
						//	e[m] =*tet_class_array[up].edge_contain[m];
						//	edge_class_array[e[m]].set_to_split1 ();
						//};

						//already_split_edge1 = *tet_class_array[up].greena_edge;
						//already_split_edge1_node = tet_class_array[up].greena_edge_split_node;
						//edge_class_array[already_split_edge1].set_have_split1 ();
						//edge_class_array[already_split_edge1].point_to_existig_split_node (already_split_edge1_node);



						tet_split_count = 0;

					};
				

					if( tet_class_array[n].tet_color == have_green1b ){

						up = *tet_class_array[n].green_tet_up;

						down1 = *tet_class_array[up].green_tet1_down;
						down2 = *tet_class_array[up].green_tet2_down;
						down3 = *tet_class_array[up].green_tet3_down;
						down4 = *tet_class_array[up].green_tet4_down;

						tet_class_array[down1].set_remove_true ();
						tet_class_array[down2].set_remove_true ();
						tet_class_array[down3].set_remove_true ();
						tet_class_array[down4].set_remove_true ();

						//setting the 6 edges of the large triangle to be split

						for(long m=0; m<6; m++){

							e_o[m] = *tet_class_array[up].edge_contain[m];
							edge_class_array[e_o[m]].set_use_split_true ();

						};


						//inserting the 8 red refined triangles

						for(long m=0; m<8; m++){

							t_bp[m] = *tet_class_array[up].red_tet_backup[m];
							tet_class_array[t_bp[m]].set_remove_false ();

						};

						//tet_class_array[up].set_tet_color(to_red1);
						//tet_class_array[up].set_remove_false ();

						//for(long m=0; m<6; m++){
						//	e[m] =*tet_class_array[up].edge_contain[m];
						//	edge_class_array[e[m]].set_to_split1 ();
						//};

						//already_split_edge1 = *tet_class_array[up].greenb_edge1;
						//already_split_edge2 = *tet_class_array[up].greenb_edge2;
						//already_split_edge1_node = tet_class_array[up].greenb_edge1_split_node;
						//already_split_edge2_node = tet_class_array[up].greenb_edge1_split_node;
						//edge_class_array[already_split_edge1].set_have_split1 ();
						//edge_class_array[already_split_edge2].set_have_split1 ();
						//edge_class_array[already_split_edge1].point_to_existig_split_node (already_split_edge1_node);
						//edge_class_array[already_split_edge2].point_to_existig_split_node (already_split_edge2_node);


						tet_split_count = 0;
					};


					if( (tet_class_array[n].tet_color == have_green1c) ){

						up = *tet_class_array[n].green_tet_up;

						down1 = *tet_class_array[up].green_tet1_down;
						down2 = *tet_class_array[up].green_tet2_down;
						down3 = *tet_class_array[up].green_tet3_down;
						down4 = *tet_class_array[up].green_tet4_down;

						tet_class_array[down1].set_remove_true ();
						tet_class_array[down2].set_remove_true ();
						tet_class_array[down3].set_remove_true ();
						tet_class_array[down4].set_remove_true ();

						//setting the 6 edges of the large triangle to be split

						for(long m=0; m<6; m++){

							e_o[m] = *tet_class_array[up].edge_contain[m];
							edge_class_array[e_o[m]].set_use_split_true ();

						};


						//inserting the 8 red refined triangles

						for(long m=0; m<8; m++){

							t_bp[m] = *tet_class_array[up].red_tet_backup[m];
							tet_class_array[t_bp[m]].set_remove_false ();

						};

						//tet_class_array[up].set_tet_color(to_red1);
						//tet_class_array[up].set_remove_false ();

						//for(long m=0; m<6; m++){
						//	e[m] =*tet_class_array[up].edge_contain[m];
						//	edge_class_array[e[m]].set_to_split1 ();
						//};

						//already_split_edge1 = *tet_class_array[up].greenc_edge1;
						//already_split_edge2 = *tet_class_array[up].greenc_edge2;
						//already_split_edge3 = *tet_class_array[up].greenc_edge3;
						//already_split_edge1_node = tet_class_array[up].greenc_edge1_split_node;
						//already_split_edge2_node = tet_class_array[up].greenc_edge2_split_node;
						//already_split_edge3_node = tet_class_array[up].greenc_edge3_split_node;
						//edge_class_array[already_split_edge1].set_have_split1 ();
						//edge_class_array[already_split_edge2].set_have_split1 ();
						//edge_class_array[already_split_edge3].set_have_split1 ();
						//edge_class_array[already_split_edge1].point_to_existig_split_node (already_split_edge1_node);
						//edge_class_array[already_split_edge2].point_to_existig_split_node (already_split_edge2_node);
						//edge_class_array[already_split_edge3].point_to_existig_split_node (already_split_edge3_node);


						tet_split_count = 0;
					};

				};








				////////////////////////////////////////////////////////////////////////////////////////

				if(tet_split_count == 1){
					tet_class_array[n].set_tet_color(to_green1a);
					ptr_to_greena_edge = edge_class_array[e_s[0]].edge_number;
					tet_class_array[n].set_greena_edge (ptr_to_greena_edge);
				};

				if(tet_split_count == 2){

					//check if the edges are on the same face.  if so mark the third edge. if not set to green1b
					greenb_mark = true;

					for(long u=0; u<4; u++){

						if( ( (*face_class_array[f[u]].edge_contain[0] == e_s[0]) && (*face_class_array[f[u]].edge_contain[1] == e_s[1]) )
							|| ( (*face_class_array[f[u]].edge_contain[0] == e_s[1]) && (*face_class_array[f[u]].edge_contain[1] == e_s[0]) ) ){

							new_edge_to_split = *face_class_array[f[u]].edge_contain[2];
							if(edge_class_array[new_edge_to_split].edge_split == no_split){
								edge_class_array[new_edge_to_split].set_to_split1 ();
							};
							e_s[2]= new_edge_to_split;
							tet_split_count = tet_split_count + 1;
							greenb_mark = false;

						};

						if( ( (*face_class_array[f[u]].edge_contain[0] == e_s[0]) && (*face_class_array[f[u]].edge_contain[2] == e_s[1]) )
							|| ( (*face_class_array[f[u]].edge_contain[0] == e_s[1]) && (*face_class_array[f[u]].edge_contain[2] == e_s[0]) ) ){

							new_edge_to_split = *face_class_array[f[u]].edge_contain[1];
							if(edge_class_array[new_edge_to_split].edge_split == no_split){
								edge_class_array[new_edge_to_split].set_to_split1 ();
							};
							e_s[2]= new_edge_to_split;
							tet_split_count = tet_split_count + 1;
							greenb_mark = false;

						};

						if( ( (*face_class_array[f[u]].edge_contain[1] == e_s[0]) && (*face_class_array[f[u]].edge_contain[2] == e_s[1]) )
							||( (*face_class_array[f[u]].edge_contain[1] == e_s[1]) && (*face_class_array[f[u]].edge_contain[2] == e_s[0]) ) ){

							new_edge_to_split = *face_class_array[f[u]].edge_contain[0];
							if(edge_class_array[new_edge_to_split].edge_split == no_split){
								edge_class_array[new_edge_to_split].set_to_split1 ();
							};
							e_s[2]= new_edge_to_split;
							tet_split_count = tet_split_count + 1;
							greenb_mark = false;

						};

					};

					if(greenb_mark == true){

						tet_class_array[n].set_tet_color(to_green1b);
						ptr_to_greenb_edge1 = edge_class_array[e_s[0]].edge_number;
						ptr_to_greenb_edge2 = edge_class_array[e_s[1]].edge_number;
						tet_class_array[n].greenb_edge1 =  edge_class_array[0].edge_number;
						tet_class_array[n].greenb_edge2 =  edge_class_array[1].edge_number;


						tet_class_array[n].set_greenb_edge (ptr_to_greenb_edge1, ptr_to_greenb_edge2);

					};

				};

				if(tet_split_count == 3){

					for(long u=0; u<4; u++){

						if(*face_class_array[f[u]].edge_contain[0] == e_s[0]){
							if(*face_class_array[f[u]].edge_contain[1] == e_s[1]){
								if(*face_class_array[f[u]].edge_contain[2] == e_s[2]){
									tet_class_array[n].set_tet_color(to_green1c);
									ptr_to_greenc_edge1 = edge_class_array[e_s[0]].edge_number;
									ptr_to_greenc_edge2 = edge_class_array[e_s[1]].edge_number;
									ptr_to_greenc_edge3 = edge_class_array[e_s[2]].edge_number;								
									tet_class_array[n].set_greenc_edge (ptr_to_greenc_edge1, ptr_to_greenc_edge2, ptr_to_greenc_edge3);
									greenc_mark = true;
								}
							};
							if(*face_class_array[f[u]].edge_contain[1] == e_s[2]){
								if(*face_class_array[f[u]].edge_contain[2] == e_s[1]){
									tet_class_array[n].set_tet_color(to_green1c);
									ptr_to_greenc_edge1 = edge_class_array[e_s[0]].edge_number;
									ptr_to_greenc_edge2 = edge_class_array[e_s[1]].edge_number;
									ptr_to_greenc_edge3 = edge_class_array[e_s[2]].edge_number;
									tet_class_array[n].set_greenc_edge (ptr_to_greenc_edge1, ptr_to_greenc_edge2, ptr_to_greenc_edge3);
									greenc_mark = true;
								}
							};
						};

						if(*face_class_array[f[u]].edge_contain[0] == e_s[1]){
							if(*face_class_array[f[u]].edge_contain[1] == e_s[0]){
								if(*face_class_array[f[u]].edge_contain[2] == e_s[2]){
									tet_class_array[n].set_tet_color(to_green1c);
									ptr_to_greenc_edge1 = edge_class_array[e_s[0]].edge_number;
									ptr_to_greenc_edge2 = edge_class_array[e_s[1]].edge_number;
									ptr_to_greenc_edge3 = edge_class_array[e_s[2]].edge_number;
									tet_class_array[n].set_greenc_edge (ptr_to_greenc_edge1, ptr_to_greenc_edge2, ptr_to_greenc_edge3);
									greenc_mark = true;
								}
							};
							if(*face_class_array[f[u]].edge_contain[1] == e_s[2]){
								if(*face_class_array[f[u]].edge_contain[2] == e_s[0]){
									tet_class_array[n].set_tet_color(to_green1c);
									ptr_to_greenc_edge1 = edge_class_array[e_s[0]].edge_number;
									ptr_to_greenc_edge2 = edge_class_array[e_s[1]].edge_number;
									ptr_to_greenc_edge3 = edge_class_array[e_s[2]].edge_number;
									tet_class_array[n].set_greenc_edge (ptr_to_greenc_edge1, ptr_to_greenc_edge2, ptr_to_greenc_edge3);
									greenc_mark = true;
								}
							};
						};

						if(*face_class_array[f[u]].edge_contain[0] == e_s[2]){
							if(*face_class_array[f[u]].edge_contain[1] == e_s[0]){
								if(*face_class_array[f[u]].edge_contain[2] == e_s[1]){
									tet_class_array[n].set_tet_color(to_green1c);
									ptr_to_greenc_edge1 = edge_class_array[e_s[0]].edge_number;
									ptr_to_greenc_edge2 = edge_class_array[e_s[1]].edge_number;
									ptr_to_greenc_edge3 = edge_class_array[e_s[2]].edge_number;
									tet_class_array[n].set_greenc_edge (ptr_to_greenc_edge1, ptr_to_greenc_edge2, ptr_to_greenc_edge3);
									greenc_mark = true;
								}
							};
							if(*face_class_array[f[u]].edge_contain[1] == e_s[1]){
								if(*face_class_array[f[u]].edge_contain[2] == e_s[0]){
									tet_class_array[n].set_tet_color(to_green1c);
									ptr_to_greenc_edge1 = edge_class_array[e_s[0]].edge_number;
									ptr_to_greenc_edge2 = edge_class_array[e_s[1]].edge_number;
									ptr_to_greenc_edge3 = edge_class_array[e_s[2]].edge_number;
									tet_class_array[n].set_greenc_edge (ptr_to_greenc_edge1, ptr_to_greenc_edge2, ptr_to_greenc_edge3);
									greenc_mark = true;
								}
							};
						};
					
					};

				};

				if( (tet_split_count >= 3) && (greenc_mark == false) ){

					tet_class_array[n].set_tet_color(to_red1);

					for(long m=0; m<6; m++){
						e[m] =*tet_class_array[n].edge_contain[m];
						if(edge_class_array[e[m]].edge_split == no_split){
							edge_class_array[e[m]].set_to_split1 ();
						};
					};

				};

			};

		};

	};

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//compute green class array sizes
//the tet class array does not include the red refined tets.  tet_class_array_size_total includes both the number of old tets
//and number of red refined tets

long green_tet_size (tet tet_class_array[], long tet_class_array_size, long tet_class_array_size_total){

	long green_tet_size_count = 0;

	for(long n=0; n<tet_class_array_size; n++){

		if(tet_class_array[n].removed == false){

		if(tet_class_array[n].tet_color == to_green1a){
			green_tet_size_count = green_tet_size_count + 2;
		};

		if(tet_class_array[n].tet_color == to_green1b){
			green_tet_size_count = green_tet_size_count + 4;
		};

		if(tet_class_array[n].tet_color == to_green1c){
			green_tet_size_count = green_tet_size_count + 4;
		};

		};

	};

	return green_tet_size_count;

}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*

void assign_split_nodes_to_green_tets(tet tet_class_array[], long tet_class_array_size, edge edge_class_array[]){

	long e1;
	long e2;
	long e3;

	long *ptr_to_greena_edge_split_node;
	long *ptr_to_greenb_edge1_split_node;
	long *ptr_to_greenb_edge2_split_node;
	long *ptr_to_greenc_edge1_split_node;
	long *ptr_to_greenc_edge2_split_node;
	long *ptr_to_greenc_edge3_split_node;


	for(long n=0; n<tet_class_array_size; n++){

		if( (tet_class_array[n].tet_color == to_green1a) && (tet_class_array[n].removed == false) ){

			e1 = *tet_class_array[n].greena_edge;
			ptr_to_greena_edge_split_node = edge_class_array[e1].split_node;
			tet_class_array[n].set_greena_edge_split_node( ptr_to_greena_edge_split_node);

		}

		if( (tet_class_array[n].tet_color == to_green1b) && (tet_class_array[n].removed == false) ){

			e1 = *tet_class_array[n].greenb_edge1;
			e2 = *tet_class_array[n].greenb_edge2;
			ptr_to_greenb_edge1_split_node = edge_class_array[e1].split_node;
			ptr_to_greenb_edge2_split_node = edge_class_array[e2].split_node;
			tet_class_array[n].set_greenb_edge_split_node(ptr_to_greenb_edge1_split_node, ptr_to_greenb_edge2_split_node);

		}

		if((tet_class_array[n].tet_color == to_green1c) && (tet_class_array[n].removed == false) ){

			e1 = *tet_class_array[n].greenc_edge1;
			e2 = *tet_class_array[n].greenc_edge2;
			e3 = *tet_class_array[n].greenc_edge3;
			ptr_to_greenc_edge1_split_node = edge_class_array[e1].split_node;
			ptr_to_greenc_edge2_split_node = edge_class_array[e2].split_node;
			ptr_to_greenc_edge3_split_node = edge_class_array[e3].split_node;
			tet_class_array[n].set_greenc_edge_split_node(ptr_to_greenc_edge1_split_node, ptr_to_greenc_edge2_split_node, ptr_to_greenc_edge3_split_node);

		}
	};


}



*/



////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////



void green_refine(tet tet_class_array[], tet new_tet_class_array[], long tet_class_array_size, long new_tet_array[], edge edge_class_array[], short level_input, parameters &param){

	long *p1;
	long *p2;
	long *p3;
	long *p4;

	long *p_n1;
	long *p_n2;
	long *p_n3;

	long *p_t1;
	long *p_t2;
	long *p_t3;
	long *p_t4;

	long e1;
	long e2;
	long e3;

	long t_num = 0;

	long *tet_pointer;
	long *tet_pointer1;
	long *tet_pointer2;
	long *tet_pointer3;
	long *tet_pointer4;


	for(long n=0; n<tet_class_array_size; n++){

		if( (tet_class_array[n].tet_color == to_green1a) && (tet_class_array[n].removed == false) ){

			

			e1 = *tet_class_array[n].greena_edge;
			p1 = edge_class_array[e1].node1;
			p2 = edge_class_array[e1].node2;
			p_n1 = edge_class_array[e1].split_node;

			p_t1 = tet_class_array[n].node1;
			p_t2 = tet_class_array[n].node2;
			p_t3 = tet_class_array[n].node3;
			p_t4 = tet_class_array[n].node4;

			//find the two points not on the split edge

			if( (*p_t1 != *p1) && (*p_t1 != *p2) ){

				p3 = p_t1;
				if( (*p_t2 != *p1) && (*p_t2 != *p2) ){
					p4 = p_t2;
				};
				if( (*p_t3 != *p1) && (*p_t3 != *p2) ){
					p4 = p_t3;
				};
				if( (*p_t4 != *p1) && (*p_t4 != *p2) ){
					p4 = p_t4;
				};
	
			}
			else{

			if( (*p_t2 != *p1) && (*p_t2 != *p2) ){

				p3 = p_t2;
				if( (*p_t3 != *p1) && (*p_t3 != *p2) ){
					p4 = p_t3;
				};
				if( (*p_t4 != *p1) && (*p_t4 != *p2) ){
					p4 = p_t4;
				};
	
			}
			else{

			if( (*p_t3 != *p1) && (*p_t3 != *p2) ){

				p3 = p_t3;
				if( (*p_t4 != *p1) && (*p_t4 != *p2) ){
					p4 = p_t4;
				};

			};
			};
			};

			//make two new triangles

			if(param.use_lite == false){


			new_tet_class_array[t_num].new_tet(p_n1, p3, p4, p1, t_num, new_tet_array, have_green1a, level_input);
			new_tet_class_array[t_num+1].new_tet(p_n1, p3, p4, p2, t_num+1, new_tet_array, have_green1a, level_input);
			

			//remove old triangle

			tet_class_array[n].set_remove_true ();

			tet_pointer = tet_class_array[n].tet_number;
			new_tet_class_array[t_num].set_green_up(tet_pointer);
			new_tet_class_array[t_num+1].set_green_up(tet_pointer);

			tet_pointer1 = new_tet_class_array[t_num].tet_number;
			tet_pointer2 = new_tet_class_array[t_num+1].tet_number;
			tet_class_array[n].set_greena_tet_down(tet_pointer1, tet_pointer2);

			t_num = t_num + 2;

			tet_class_array[n].set_remove_true ();

			}else{

			//new_tet_class_array[t_num].new_tet(p_n1, p3, p4, p1, t_num, new_tet_array, have_green1a, level_input);
			//new_tet_class_array[t_num+1].new_tet(p_n1, p3, p4, p2, t_num+1, new_tet_array, have_green1a, level_input);
			param.tet_class_array_green5[t_num].new_tet_lite(p_n1,p3,p4,p1,t_num,new_tet_array);
			param.tet_class_array_green5[t_num+1].new_tet_lite(p_n1,p3,p4,p2,t_num+1,new_tet_array);			

			//remove old triangle

			tet_class_array[n].set_remove_true ();

			//tet_pointer = tet_class_array[n].tet_number;
			//new_tet_class_array[t_num].set_green_up(tet_pointer);
			//new_tet_class_array[t_num+1].set_green_up(tet_pointer);

			//tet_pointer1 = new_tet_class_array[t_num].tet_number;
			//tet_pointer2 = new_tet_class_array[t_num+1].tet_number;
			//tet_class_array[n].set_greena_tet_down(tet_pointer1, tet_pointer2);

			t_num = t_num + 2;

			tet_class_array[n].set_remove_true ();


			}
			}


		if( (tet_class_array[n].tet_color == to_green1b) && (tet_class_array[n].removed == false)  ){

			e1 = *tet_class_array[n].greenb_edge1;
			e2 = *tet_class_array[n].greenb_edge2;
			p1 = edge_class_array[e1].node1;
			p2 = edge_class_array[e1].node2;
			p3 = edge_class_array[e2].node1;
			p4 = edge_class_array[e2].node2;

			p_n1 = edge_class_array[e1].split_node;
			p_n2 = edge_class_array[e2].split_node;

			if(param.use_lite == false){

			new_tet_class_array[t_num].new_tet(p_n1, p_n2, p1, p3, t_num, new_tet_array, have_green1b, level_input);
			new_tet_class_array[t_num+1].new_tet(p_n1, p_n2, p1, p4, t_num+1, new_tet_array, have_green1b, level_input);
			new_tet_class_array[t_num+2].new_tet(p_n1, p_n2, p2, p3, t_num+2, new_tet_array, have_green1b, level_input);
			new_tet_class_array[t_num+3].new_tet(p_n1, p_n2, p2, p4, t_num+3, new_tet_array, have_green1b, level_input);

			tet_class_array[n].set_remove_true ();

			tet_pointer = tet_class_array[n].tet_number;
			new_tet_class_array[t_num].set_green_up(tet_pointer);
			new_tet_class_array[t_num+1].set_green_up(tet_pointer);
			new_tet_class_array[t_num+2].set_green_up(tet_pointer);
			new_tet_class_array[t_num+3].set_green_up(tet_pointer);

			tet_pointer1 = new_tet_class_array[t_num].tet_number;
			tet_pointer2 = new_tet_class_array[t_num+1].tet_number;
			tet_pointer3 = new_tet_class_array[t_num+2].tet_number;
			tet_pointer4 = new_tet_class_array[t_num+3].tet_number;
			tet_class_array[n].set_greenb_tet_down(tet_pointer1, tet_pointer2, tet_pointer3, tet_pointer4);

			t_num = t_num + 4;

			tet_class_array[n].set_remove_true ();

			}else{

			//new_tet_class_array[t_num].new_tet(p_n1, p_n2, p1, p3, t_num, new_tet_array, have_green1b, level_input);
			//new_tet_class_array[t_num+1].new_tet(p_n1, p_n2, p1, p4, t_num+1, new_tet_array, have_green1b, level_input);
			//new_tet_class_array[t_num+2].new_tet(p_n1, p_n2, p2, p3, t_num+2, new_tet_array, have_green1b, level_input);
			//new_tet_class_array[t_num+3].new_tet(p_n1, p_n2, p2, p4, t_num+3, new_tet_array, have_green1b, level_input);
			param.tet_class_array_green5[t_num].new_tet_lite(p_n1,p_n2,p1,p3,t_num,new_tet_array);
			param.tet_class_array_green5[t_num+1].new_tet_lite(p_n1,p_n2,p1,p4,t_num+1,new_tet_array);
			param.tet_class_array_green5[t_num+2].new_tet_lite(p_n1,p_n2,p2,p3,t_num+2,new_tet_array);
			param.tet_class_array_green5[t_num+3].new_tet_lite(p_n1,p_n2,p2,p4,t_num+3,new_tet_array);

			tet_class_array[n].set_remove_true ();


			t_num = t_num + 4;

			tet_class_array[n].set_remove_true ();


			}


		};

		if((tet_class_array[n].tet_color == to_green1c) && (tet_class_array[n].removed == false) ){

			// new point 1 between 1 and 2
			// new point 2 between 1 and 3
			// new point 3 between 2 and 3

			e1 = *tet_class_array[n].greenc_edge1;
			p1 = edge_class_array[e1].node1;
			p2 = edge_class_array[e1].node2;
			p_n1 = edge_class_array[e1].split_node;

			e2 = *tet_class_array[n].greenc_edge2;
			p_t1 = edge_class_array[e2].node1;
			p_t2 = edge_class_array[e2].node2;
			p_t3 = edge_class_array[e2].split_node;

			e3 = *tet_class_array[n].greenc_edge3;
			p_t4 = edge_class_array[e3].split_node;


			if(*p_t1 == *p1){
				p3 = p_t2;
				p_n2 = p_t3;
				p_n3 = p_t4;
			};

			if(*p_t2 == *p1){
				p3 = p_t1;
				p_n2 = p_t3;
				p_n3 = p_t4;
			};

			if(*p_t1 == *p2){
				p3 = p_t2;
				p_n3 = p_t3;
				p_n2 = p_t4;
			};

			if(*p_t2 == *p2){
				p3 = p_t1;
				p_n3 = p_t3;
				p_n2 = p_t4;	
			};

			//finding the 4th point

			p_t1 = tet_class_array[n].node1;
			p_t2 = tet_class_array[n].node2;
			p_t3 = tet_class_array[n].node3;
			p_t4 = tet_class_array[n].node4;

			if( (*p_t1 != *p1) && (*p_t1 != *p2) && (*p_t1 != *p3) ){
				p4 = p_t1;
			}

			if( (*p_t2 != *p1) && (*p_t2 != *p2) && (*p_t2 != *p3) ){
				p4 = p_t2;
			}

			if( (*p_t3 != *p1) && (*p_t3 != *p2) && (*p_t3 != *p3) ){
				p4 = p_t3;
			}

			if( (*p_t4 != *p1) && (*p_t4 != *p2) && (*p_t4 != *p3) ){
				p4 = p_t4;
			}

			if(param.use_lite == false){

			new_tet_class_array[t_num].new_tet(p4, p1, p_n1, p_n2, t_num, new_tet_array, have_green1c, level_input);
			new_tet_class_array[t_num+1].new_tet(p4, p2, p_n1, p_n3, t_num+1, new_tet_array, have_green1c, level_input);
			new_tet_class_array[t_num+2].new_tet(p4, p3, p_n2, p_n3, t_num+2, new_tet_array, have_green1c, level_input);
			new_tet_class_array[t_num+3].new_tet(p4, p_n1, p_n2, p_n3, t_num+3, new_tet_array, have_green1c, level_input);
			
			tet_class_array[n].set_remove_true ();

			tet_pointer = tet_class_array[n].tet_number;
			new_tet_class_array[t_num].set_green_up(tet_pointer);
			new_tet_class_array[t_num+1].set_green_up(tet_pointer);
			new_tet_class_array[t_num+2].set_green_up(tet_pointer);
			new_tet_class_array[t_num+3].set_green_up(tet_pointer);

			tet_pointer1 = new_tet_class_array[t_num].tet_number;
			tet_pointer2 = new_tet_class_array[t_num+1].tet_number;
			tet_pointer3 = new_tet_class_array[t_num+2].tet_number;
			tet_pointer4 = new_tet_class_array[t_num+3].tet_number;
			tet_class_array[n].set_greenc_tet_down(tet_pointer1, tet_pointer2, tet_pointer3, tet_pointer4);

			t_num = t_num + 4;

			tet_class_array[n].set_remove_true ();

			}else{

			//new_tet_class_array[t_num].new_tet(p4, p1, p_n1, p_n2, t_num, new_tet_array, have_green1c, level_input);
			//new_tet_class_array[t_num+1].new_tet(p4, p2, p_n1, p_n3, t_num+1, new_tet_array, have_green1c, level_input);
			//new_tet_class_array[t_num+2].new_tet(p4, p3, p_n2, p_n3, t_num+2, new_tet_array, have_green1c, level_input);
			//new_tet_class_array[t_num+3].new_tet(p4, p_n1, p_n2, p_n3, t_num+3, new_tet_array, have_green1c, level_input);
			param.tet_class_array_green5[t_num].new_tet_lite(p4,p1,p_n1,p_n2,t_num,new_tet_array);
			param.tet_class_array_green5[t_num+1].new_tet_lite(p4,p2,p_n1,p_n3,t_num+1,new_tet_array);
			param.tet_class_array_green5[t_num+2].new_tet_lite(p4,p3,p_n2,p_n3,t_num+2,new_tet_array);
			param.tet_class_array_green5[t_num+3].new_tet_lite(p4,p_n1,p_n2,p_n3,t_num+3,new_tet_array);
			
			tet_class_array[n].set_remove_true ();

			
			t_num = t_num + 4;

			tet_class_array[n].set_remove_true ();


			}

		};

	};

}





			














