#include "parameters.h"



//enum color{no_color, red1, green1a, green1b, green1c};




// the class tet points to 4 nodes.  

class tet{
	public:
	long *tet_number;
	long *node1, *node2, *node3, *node4;

	long **edge_contain;

	//face1 is node 1,2,3; face2 is 1,2,4; face3 is 1,3,4, and face4 is 2,3,4.  But this will only be true on the triangle with the
	//lower tet number.

	long *face1, *face2, *face3, *face4;


	color tet_color;

	//creating the mesh requires both creating and removing.  'removed' is either true or false, which indicates
	//whether this class memeber should be included in the final mesh

	bool removed;

	//some removed tets may need to be put back in later.   totally_removed means the tet will never be used.  it does
	//not even have four nodes associated with it.  totally_remove true tets only come up during the initialization

	bool totally_removed;

	long *greena_edge;
	long *greenb_edge1, *greenb_edge2;
	long *greenc_edge1, *greenc_edge2, *greenc_edge3;

	//long *greena_edge_split_node;
	//long *greenb_edge1_split_node, *greenb_edge2_split_node;
	//long *greenc_edge1_split_node, *greenc_edge2_split_node, *greenc_edge3_split_node;

	//the variables below are useful for red refining a tet that has already been green refined

	long *green_tet_up;

	long *green_tet1_down, *green_tet2_down, *green_tet3_down, *green_tet4_down;

	long **red_tet_backup;

	//level refers to how many times the tet has been refined smaller

	short level;

	void set_remove_false();

	void set_remove_true();

	void set_totally_remove_true ();

	void initialize_tet (long tet_number_input, long node1_input, long node2_input, long node3_input, long node4_input, long tet_array_initial[], long node_array_grid1[], long node_array_grid2[],parameters &param);



	//void set_no_color ();

	//void set_to_red1 ();

	//void set_have_red1 ();

	void set_face1 (long* pointer_to_face1);
	void set_face2 (long* pointer_to_face2);
	void set_face3 (long* pointer_to_face3);
	void set_face4 (long* pointer_to_face4);

	void set_edge_number ();

	void set_edge (long* pointer_to_edge, long edge_number);

	void new_tet (long *node1_ptr, long *node2_ptr, long *node3_ptr, long *node4_ptr, long t_num, long new_tet_array[], color this_tet_color, short level_input);

	void set_tet_color (color this_tet_color);

	void set_greena_edge (long *ptr_to_greena_edge);
	void set_greenb_edge (long *ptr_to_greenb_edge1, long *ptr_to_greenb_edge2);
	void set_greenc_edge (long *ptr_to_greenc_edge1, long *ptr_to_greenc_edge2, long *ptr_to_greenc_edge3);

	//void set_greena_edge_split_node (long *ptr_to_greena_edge_split_node);
	//void set_greenb_edge_split_node (long *ptr_to_greenb_edge1_split_node, long *ptr_to_greenb_edge2_split_node);
	//void set_greenc_edge_split_node (long *ptr_to_greenc_edge1_split_node, long *ptr_to_greenc_edge2_split_node, long *ptr_to_greenc_edge3_split_node);




	void set_green_up(long* tet_pointer);

	void set_greena_tet_down(long* tet_pointer1, long* tet_pointer2);
	void set_greenb_tet_down(long* tet_pointer1, long* tet_pointer2, long* tet_pointer3, long* tet_pointer4);
	void set_greenc_tet_down(long* tet_pointer1, long* tet_pointer2, long* tet_pointer3, long* tet_pointer4);

	void set_red_backup(long red_tet_backup[], long new_tet_array[]);



	//assign tet to a brain region

	short region;

	void set_region(short region_input);


};